<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.1"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format"
                xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                xsi:schemaLocation="http://www.w3.org/1999/XSL/Format
                http://svn.apache.org/repos/asf/xmlgraphics/fop/trunk/src/foschema/fop.xsd"
                exclude-result-prefixes="fo">
    <xsl:output method="xml" version="1.0" omit-xml-declaration="no"
                indent="yes" />

    <xsl:template match="/">
        <fo:root>
            <fo:layout-master-set>
                <fo:simple-page-master master-name="A4-portrait" page-height="29.7cm" page-width="21.0cm" margin="2cm">
                    <fo:region-body/>
                </fo:simple-page-master>
            </fo:layout-master-set>

            <fo:page-sequence master-reference="A4-portrait">
                <fo:flow flow-name="xsl-region-body">
                    <fo:block space-after="2mm">
                        <fo:table width="100%">
                            <fo:table-body>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="4">
                                        <fo:block font-weight="bold">
                                            Вид испытания
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block>
                                            <xsl:value-of select="simulations/typeName" />
                                        </fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="4">
                                        <fo:block font-weight="bold">
                                            Нормативный документ
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block>
                                            <xsl:value-of select="simulations/standartName" />
                                        </fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="4">
                                        <fo:block font-weight="bold">
                                            Материал
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block>
                                            <xsl:value-of select="simulations/materialName" />
                                        </fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="4">
                                        <fo:block font-weight="bold">
                                            Представительный элемент объема
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block>
                                            <xsl:value-of select="simulations/ecName" />
                                        </fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block font-weight="bold">
                                            Дата создания
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block>
                                            <xsl:value-of select="simulations/creationDate" />
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2" number-rows-spanned="2">
                                        <fo:block/>
                                    </fo:table-cell>
                                </fo:table-row>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block font-weight="bold">
                                            Пользователь
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block>
                                            <xsl:value-of select="simulations/userName" />
                                        </fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-body>
                        </fo:table>
                    </fo:block>
                    <!-- ###################################################################################################### -->
                    <fo:block space-after="2mm">
                        <fo:table width="100%">
                            <fo:table-body>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle"
                                                   display-align="center" number-columns-spanned="6">
                                        <fo:block-container height="5cm">
                                            <fo:block text-align="center">
                                                <fo:external-graphic content-height="5cm" src="">
                                                    <xsl:attribute name="src">
                                                        <xsl:value-of select="simulations/picture" />
                                                    </xsl:attribute>
                                                </fo:external-graphic>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="6">
                                        <fo:block font-weight="bold">Размеры образца, мм</fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="3">
                                        <fo:block>H</fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="3">
                                        <fo:block><xsl:value-of select="simulations/manualSizeH" /></fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="3">
                                        <fo:block>B</fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="3">
                                        <fo:block><xsl:value-of select="simulations/manualSizeB" /></fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="3">
                                        <fo:block>L</fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="3">
                                        <fo:block><xsl:value-of select="simulations/manualSizeL" /></fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-body>
                        </fo:table>
                    </fo:block>
                    <!-- ###################################################################################################### -->
                    <fo:block space-after="2mm">
                        <fo:table width="100%">
                            <fo:table-body>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="6">
                                        <fo:block font-weight="bold">Результаты виртуального испытания</fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <xsl:for-each select="simulations/results/parameter">
                                    <xsl:choose>
                                        <xsl:when test="isComposite = 'true'">
                                            <fo:table-row>
                                                <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="6">
                                                    <fo:block><xsl:value-of select="name" /></fo:block>
                                                </fo:table-cell>
                                            </fo:table-row>
                                            <xsl:for-each select="children">
                                                <fo:table-row>
                                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="3">
                                                        <fo:block><xsl:value-of select="name" /></fo:block>
                                                    </fo:table-cell>
                                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="3">
                                                        <fo:block><xsl:value-of select="value" /></fo:block>
                                                    </fo:table-cell>
                                                </fo:table-row>
                                            </xsl:for-each>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <fo:table-row>
                                                <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="4">
                                                    <fo:block><xsl:value-of select="name" /></fo:block>
                                                </fo:table-cell>
                                                <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                                    <fo:block><xsl:value-of select="value" /></fo:block>
                                                </fo:table-cell>
                                            </fo:table-row>
                                        </xsl:otherwise>
                                    </xsl:choose>
                                </xsl:for-each>
                            </fo:table-body>
                        </fo:table>
                    </fo:block>
                    <!-- ###################################################################################################### -->
                    <fo:block space-after="2mm">
                        <fo:table width="100%">
                            <fo:table-body>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle"
                                                   display-align="center" number-columns-spanned="3">
                                        <fo:block-container height="7cm">
                                            <fo:block text-align="center">
                                                <fo:external-graphic content-height="6cm" src="">
                                                    <xsl:attribute name="src">
                                                        <xsl:value-of select="simulations/fiberPic" />
                                                    </xsl:attribute>
                                                </fo:external-graphic>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle"
                                                   display-align="center" number-columns-spanned="3">
                                        <fo:block-container height="7cm">
                                            <fo:block text-align="center">
                                                <fo:external-graphic content-height="6cm" src="">
                                                    <xsl:attribute name="src">
                                                        <xsl:value-of select="simulations/matrixPic" />
                                                    </xsl:attribute>
                                                </fo:external-graphic>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-body>
                        </fo:table>
                    </fo:block>
                </fo:flow>
            </fo:page-sequence>

        </fo:root>
    </xsl:template>

</xsl:stylesheet>