package ru.crp.lvms;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.messaging.simp.SimpMessagingTemplate;
import org.springframework.messaging.simp.annotation.SubscribeMapping;
import org.springframework.stereotype.Controller;
import ru.crp.lvms.cluster.ClustersManager;
import ru.crp.lvms.cluster.model.ClusterInfo;

import java.util.List;

import static ru.crp.lvms.cluster.ClustersManager.CLUSTER_INFO_QUEUE;

// WARN need to be added to root application context (not AC that belongs to dispatcher servlet)
// because this bean must be present while initializing websockets to be added to message handlers list
// See org.springframework.messaging.handler.invocation.AbstractMethodMessageHandler.detectHandlerMethods
@Controller
public class StompController {
    private static final Logger LOGGER = LoggerFactory.getLogger(StompController.class);
    @Autowired
    private ClustersManager clustersManager;


    @Autowired
    private SimpMessagingTemplate messagingTemplate;


    @SubscribeMapping(CLUSTER_INFO_QUEUE)
    public List<ClusterInfo> initNodesSubscription() {
        return clustersManager.getFreshClustersInfo();
    }
}
