package ru.crp.lvms.chart;

import java.util.ArrayList;
import java.util.List;

public class ChartsSet {

    private String title;
    protected List<String> description;

    private String xAxisLabel;
    private String yAxisLabel;

    private String xDimension;
    private String yDimension;

    private AxisDomainType domainX;
    private AxisDomainType domainY;

    private List<Chart> charts;
    private Point highlightPoint;

    // for json deserialization
    public ChartsSet() {
        domainX = AxisDomainType.EXPONENTIAL;
        domainY = AxisDomainType.EXPONENTIAL;
        charts = new ArrayList<>();
    }

    public ChartsSet(String title, String xAxisLabel, String xDimension, String yAxisLabel, String yDimension) {
        this();
        this.title = title;

        this.xAxisLabel = xAxisLabel;
        this.xDimension = xDimension;

        this.yAxisLabel = yAxisLabel;
        this.yDimension = yDimension;
    }


    public ChartsSet(String title, String xAxisLabel, String xDimension, AxisDomainType domainX,
                     String yAxisLabel, String yDimension, AxisDomainType domainY) {
        this(title, xAxisLabel, xDimension, yAxisLabel, yDimension);
        this.domainX = domainX;
        this.domainY = domainY;
    }

    public String getxDimension() {
        return xDimension;
    }

    public void setxDimension(String xDimension) {
        this.xDimension = xDimension;
    }

    public String getyDimension() {
        return yDimension;
    }

    public void setyDimension(String yDimension) {
        this.yDimension = yDimension;
    }

    public void addChart(Chart chart) {
        charts.add(chart);
    }

    public List<Chart> getCharts() {
        return charts;
    }

    public void setCharts(List<Chart> charts) {
        this.charts = charts;
    }

    public String getxAxisLabel() {
        return xAxisLabel;
    }

    public void setxAxisLabel(String xAxisLabel) {
        this.xAxisLabel = xAxisLabel;
    }

    public String getyAxisLabel() {
        return yAxisLabel;
    }

    public void setyAxisLabel(String yAxisLabel) {
        this.yAxisLabel = yAxisLabel;
    }

    public Point getHighlightPoint() {
        return highlightPoint;
    }

    public void setHighlightPoint(Point highlightPoint) {
        this.highlightPoint = highlightPoint;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public AxisDomainType getDomainX() {
        return domainX;
    }

    public void setDomainX(AxisDomainType domainX) {
        this.domainX = domainX;
    }

    public AxisDomainType getDomainY() {
        return domainY;
    }

    public void setDomainY(AxisDomainType domainY) {
        this.domainY = domainY;
    }

    public List<String> getDescription() {
        return description;
    }

    public void setDescription(List<String> description) {
        this.description = description;
    }
}
