package ru.crp.lvms.cluster;

import org.springframework.jdbc.core.RowMapper;
import ru.crp.lvms.cluster.model.ClusterType;
import ru.crp.lvms.cluster.model.NodeForClusterInfoEntity;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashSet;

import static java.util.Arrays.asList;

public class NodeForClusterInfoRowMapper implements RowMapper<NodeForClusterInfoEntity> {
    @Override
    public NodeForClusterInfoEntity mapRow(ResultSet rs, int rowNum) throws SQLException {
        return new NodeForClusterInfoEntity(
                rs.getInt("id"),
                rs.getInt("cluster_id"),
                rs.getString("name"),
                ClusterType.valueOf(rs.getInt("type_id")),
                rs.getBoolean("is_alive"),
                rs.getBoolean("is_enabled"),
                rs.getInt("num_cores"),
                rs.getInt("memory"),
                rs.getBoolean("is_busy"),
                new HashSet<>(asList((String[]) rs.getArray("enabled_solvers").getArray()))
        );
    }
}
