package ru.crp.lvms.cluster.model;


import java.util.Set;

public class NodeForClusterInfoEntity {
    private int id;

    private int clusterId;
    private String clusterName;

    private ClusterType clusterType;
    private boolean isAlive;
    private boolean isEnabled;
    private int numOfCores;
    private int memory;
    private boolean isBusy; // means there is some task that is running on node
    private Set<String> enabledSolvers;

    public NodeForClusterInfoEntity(int id, int clusterId, String clusterName, ClusterType clusterType,
                                    boolean isAlive, boolean isEnabled, int numOfCores, int memory, boolean isBusy, Set<String> enabledSolvers) {
        this.id = id;
        this.clusterId = clusterId;
        this.isAlive = isAlive;
        this.isEnabled = isEnabled;
        this.numOfCores = numOfCores;
        this.memory = memory;
        this.isBusy = isBusy;
        this.enabledSolvers = enabledSolvers;
        this.clusterType = clusterType;
        this.clusterName = clusterName;
    }

    public int getId() {
        return id;
    }

    public boolean isAlive() {
        return isAlive;
    }

    public boolean isEnabled() {
        return isEnabled;
    }

    public int getNumOfCores() {
        return numOfCores;
    }

    public int getMemory() {
        return memory;
    }

    public boolean isBusy() {
        return isBusy;
    }

    public Set<String> getEnabledSolvers() {
        return enabledSolvers;
    }

    public int getClusterId() {
        return clusterId;
    }

    public ClusterType getClusterType() {
        return clusterType;
    }

    public String getClusterName() {
        return clusterName;
    }
}
