package ru.crp.lvms.exceptions;

public class EntityDeleteException extends RuntimeException {
    private final boolean hasNotDeletedDependency;
    public EntityDeleteException(String message) {
        super(message);
        hasNotDeletedDependency = false;
    }

    public EntityDeleteException(String message, Throwable cause) {
        super(message, cause);
        hasNotDeletedDependency = false;
    }

    public EntityDeleteException(String message, boolean hasNotDeletedDependency) {
        super(message);
        this.hasNotDeletedDependency = hasNotDeletedDependency;
    }

    public boolean isHasNotDeletedDependency() {
        return hasNotDeletedDependency;
    }
}
