package ru.crp.lvms.exceptions;

public class NotFoundException extends RuntimeException {
    private int id;
    private Class<?> entityClass;

    public NotFoundException(String message, Throwable cause) {
        super(message, cause);
    }

    public NotFoundException(int id, Class<?> entityClass) {
        this.id = id;
        this.entityClass = entityClass;
    }

    public NotFoundException(String message) {
        super(message);
        this.id = 0;
        this.entityClass = null;
    }

    public int getId() {
        return id;
    }

    public Class<?> getEntityClass() {
        return entityClass;
    }

    @Override
    public String getMessage() {
        if (entityClass != null) {
            return "Объект с типом " + entityClass.getSimpleName() + " и номером " + id + " не найден";
        }
        return super.getMessage();
    }
}
