package ru.crp.lvms.managers.construction.elements;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.crp.lvms.managers.misc.BaseManagerSuggest;
import ru.crp.lvms.model.AccessRights;
import ru.crp.lvms.model.dao.BaseSpaceDao;
import ru.crp.lvms.model.dao.construction.elements.AdjacentElementDao;
import ru.crp.lvms.model.entities.UserEntity;
import ru.crp.lvms.model.entities.construction.elements.AdjacentElementsEntityTable;

import java.util.List;

@Service
public class AdjacentElementManager extends BaseManagerSuggest<AdjacentElementsEntityTable> {

    @Autowired
    private AdjacentElementDao adjacentElementDao;

    @Autowired
    private ConstructionElementManager constructionElementManager;

    @Override
    protected BaseSpaceDao<AdjacentElementsEntityTable> aliveDao() {
        return adjacentElementDao;
    }

    public AdjacentElementsEntityTable adjacentConstructions(Integer entityId, Integer adjId, UserEntity currentUser) {
        AdjacentElementsEntityTable adj = new AdjacentElementsEntityTable();
        adj.setConstructionElementId(entityId);
        adj.setAdjacentElementId(adjId);
        return adjacentElementDao.insertAndRead(adj);
    }

    public List<AdjacentElementsEntityTable> getAdjacents(Integer constructionElementId, UserEntity currentUser) {
        constructionElementManager.checkEntityExistsAndAccesible(constructionElementId, AccessRights.view, currentUser);
        return adjacentElementDao.findByConstructionElementId(constructionElementId);
    }

    public void deleteAdjacent(Integer constructionElementId, Integer adjId, UserEntity currentUser) {
        constructionElementManager.checkEntityExistsAndAccesible(constructionElementId, AccessRights.update, currentUser);
        adjacentElementDao.delete(constructionElementId, adjId);
    }
}
