package ru.crp.lvms.managers.tasks.resultsHandlers;

import org.apache.commons.io.FilenameUtils;
import ru.crp.cmls.calculations.solvers.xml.config.ResultType;
import ru.crp.lvms.managers.tasks.ResultsParent;
import ru.crp.lvms.model.entities.ResultEntity;
import ru.crp.lvms.model.entities.misc.CreatedBy;

import java.nio.file.Files;
import java.nio.file.Path;
import java.util.List;

import static java.util.Collections.singletonList;

public class SlurmLogsResultHandler extends KeyResultHandler {
    public SlurmLogsResultHandler(Path pathToStorage) {
        super(pathToStorage);
    }

    @Override
    public boolean canHandle(ResultType resultType, Path pathToFile) {
        return (resultType == ResultType.slurmStdOut || resultType == ResultType.slurmStdErr) && Files.isRegularFile(pathToFile);
    }

    @Override
    protected List<ResultEntity> doHandleResultsFile(Path pathToFile, ResultsParent resultsParent, CreatedBy createdBy) {
        ResultEntity newLogFile = initCommonResultProperties(pathToFile, resultsParent, createdBy);
        newLogFile.setName(FilenameUtils.removeExtension(pathToFile.getFileName().toString()));
        newLogFile.setType(pathToFile.getFileName().toString().endsWith(".err") ? ResultType.slurmStdErr : ResultType.slurmStdOut);

        return singletonList(newLogFile);
    }
}
