package ru.crp.lvms.model.dao.construction.elements;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Repository;
import ru.crp.lvms.model.dao.BaseCompositeDao;
import ru.crp.lvms.model.dao.BaseSpaceDao;
import ru.crp.lvms.model.entities.construction.elements.ConstructionElementDocsEntity;
import ru.crp.lvms.model.entities.construction.elements.ConstructionElementDocsEntityTable;

import java.util.List;

@Repository
@Primary
public class ConstructionElementDocsDao extends BaseCompositeDao<ConstructionElementDocsEntityTable, ConstructionElementDocsEntity> {
    @Component
    public static class TableDao extends BaseSpaceDao<ConstructionElementDocsEntityTable> {

    }

    @Autowired
    private TableDao tableDao;

    @Override
    protected TableDao tableDao() {
        return tableDao;
    }

    public ConstructionElementDocsEntity insertNewDoc(ConstructionElementDocsEntityTable t) {
        Integer newDocId = tableDao().insert(t);
        return findOne(newDocId);
    }

    public List<ConstructionElementDocsEntity> findByConstructionElementId(int constructionElementId) {
        return find("WHERE construction_element_id = ?", constructionElementId);
    }
}
