package ru.crp.lvms.model.dao.effective.characteristics;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.model.dao.BaseSpaceDao;
import ru.crp.lvms.model.entities.effective.characteristics.ECDefectEntity;

import java.util.List;

@Repository
public class ECDefectDao extends BaseSpaceDao<ECDefectEntity> {
    public List<ECDefectEntity> getByCharacteristicId(Integer ecId) {
        return find("WHERE effective_characteristic_id = ? ORDER BY defectNameId", ecId);
    }

    public ECDefectEntity findOne(Integer defectId, Integer ecId) {
        return findOne("WHERE id = ? AND effective_characteristic_id = ?", defectId, ecId);
    }

    public ECDefectEntity getByCharacteristicIdAndDefectNameId(Integer defectNameId, Integer ecId) {
        return findOne("WHERE defect_name_id = ? AND effective_characteristic_id = ?", defectNameId, ecId);
    }
}
