package ru.crp.lvms.model.entities;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Suggest;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.model.entities.misc.BaseEntityTable;
import ru.crp.lvms.model.entities.misc.ItemType;
import ru.crp.lvms.validators.ParentExists;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import javax.validation.constraints.NotNull;

@Table("materials")
public class MaterialEntityTable extends BaseEntityTable implements Named {
    @Suggest()
    @GridColumn(name = "name", label = "Название", order = 0, cell = GridColumnType.uri)
    @Column("name")
    private String name;

    @GridColumn(name = "manufacture", label = "Производитель", order = 2)
    @Column("manufacture")
    private String manufacture;

    @Column("pid")
    @ParentExists(message = "Неверный путь", parentTypes = ItemType.Folder)
    @NotNull(message = "Папка должна быть задана")
    private Integer pid;

    @Column("source")
    private String source;

    @GridColumn(name = "description", label = "Описание", order = 4)
    @Column("description")
    private String description;

    @GridColumn(name = "lock", label = "Блок", cell = GridColumnType.string, order = 6)
    @Column("lock")
    private boolean lock;

    @Column("type_id")
    private Integer typeId;

    public String getSource() {
        return source;
    }

    public void setSource(String source) {
        this.source = source;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public boolean isLock() {
        return lock;
    }

    public void setLock(boolean lock) {
        this.lock = lock;
    }

    public String getManufacture() {
        return manufacture;
    }

    public void setManufacture(String manufacture) {
        this.manufacture = manufacture;
    }

    public Integer getPid() {
        return pid;
    }

    public void setPid(Integer pid) {
        this.pid = pid;
    }

    public Integer getTypeId() {
        return typeId;
    }

    public void setTypeId(Integer typeId) {
        this.typeId = typeId;
    }

    @Override
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
