package ru.crp.lvms.model.entities;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.web.dto.misc.Auditable;

import java.util.Date;

@Table("users")
public class UserEntityTable implements Entity, Named, Auditable {

    private int id;
    @Column("login")
    private String login;
    @Column("email")
    private String email;
    @Column("name")
    private String name;
    @Column("password")
    private String password;
    @Column("phone")
    private String phone;
    @Column("active")
    private boolean active;
    @Column("notified")
    private boolean notified;
    @Column("role_id")
    private int roleId;
    @Column("date_created")
    private Date creationDate;
    @Column("birth_date")
    private Date birthDate;

    @Override
    public int getId() {
        return this.id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public String getLogin() {
        return this.login;
    }

    public void setLogin(String login) {
        this.login = login;
    }

    public String getEmail() {
        return this.email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    @Override
    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPassword() {
        return this.password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getPhone() {
        return this.phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public boolean isActive() {
        return this.active;
    }

    public void setActive(boolean active) {
        this.active = active;
    }

    public boolean isNotified() {
        return notified;
    }

    public void setNotified(boolean notified) {
        this.notified = notified;
    }

    public int getRoleId() {
        return this.roleId;
    }

    public void setRoleId(int roleId) {
        this.roleId = roleId;
    }

    @Override
    public int getOwnerId() {
        return getId();
    }

    @Override
    public Date getCreationDate() {
        return creationDate != null ? new Date(creationDate.getTime()) :  null;
    }

    @Override
    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate != null ? new Date(creationDate.getTime()) : null;
    }

    public Date getBirthDate() {
        return birthDate != null ? new Date(birthDate.getTime()) :  null;
    }

    public void setBirthDate(Date birthDate) {
        this.birthDate = birthDate != null ? new Date(birthDate.getTime()) : null;
    }
}
