package ru.crp.lvms.model.entities.construction.elements;

import com.fasterxml.jackson.annotation.JsonIgnore;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.lvms.model.entities.FileEntity;
import ru.crp.lvms.model.entities.misc.BaseEntityTable;
import ru.crp.lvms.validators.Unique;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import javax.validation.constraints.NotNull;

@Table("construction_elements")
public class ConstructionElementEntityTable extends BaseEntityTable {
    @GridColumn(name = "name", label = "Конструкция", order = 0, cell = GridColumnType.uri)
    @Column("name")
    @NotNull(message = "Имя элемента конструкции должно быть задано")
    private String name;

    @Column("pid")
    @NotNull(message = "Путь должен быть задан")
    private Integer pid;

    @Column(value = "image_file_id", onlySelect = true)
    @JsonIgnore
    private Integer imageFileId;

    @Column("cad_model_id")
    private Integer initialCadModelId;

    @Column("description")
    private String description;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getImageFileId() {
        return imageFileId;
    }

    public void setImageFileId(Integer imageFileId) {
        this.imageFileId = imageFileId;
    }

    public Integer getInitialCadModelId() {
        return initialCadModelId;
    }

    public void setInitialCadModelId(Integer initialCadModelId) {
        this.initialCadModelId = initialCadModelId;
    }

    public Integer getPid() {
        return pid;
    }

    public void setPid(Integer pid) {
        this.pid = pid;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }
}
