package ru.crp.lvms.model.entities.effective.characteristics;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.web.dto.columns.GridColumn;

import javax.validation.constraints.NotNull;

@Table("effective_characteristics_defects_parameters_join")
public class ECDefectEntity implements Entity {
    private int id;

    @Column("effective_characteristic_id")
    private Integer ecId;

    @NotNull(message = "Имя дефекта должно быть задано")
    @Column("defect_name_id")
    private Integer defectNameId;

    @GridColumn(label = "Тип дефекта", name = "defectName", order = 1)
    @Column("defect_name")
    private String defectName;

    @GridColumn(label = "Процентное содержание", name = "percentage", order = 2)
    @Column("percentage")
    private Double percentage;

    @GridColumn(label = "Толщина дефекта", name = "thickness", order = 3)
    @Column("thickness")
    private Double thickness;

    @GridColumn(label = "Ширина дефекта", name = "width", order = 4)
    @Column("width")
    private Double width;

    @GridColumn(label = "Длина дефекта", name = "height", order = 5)
    @Column("length")
    private Double length;

    public ECDefectEntity() {
    }

    public ECDefectEntity(Integer defectNameId, Integer ecId) {
        this.defectNameId = defectNameId;
        this.ecId = ecId;
    }

    public Integer getEcId() {
        return ecId;
    }

    public void setEcId(Integer ecId) {
        this.ecId = ecId;
    }

    public Integer getDefectNameId() {
        return defectNameId;
    }

    public void setDefectNameId(Integer defectNameId) {
        this.defectNameId = defectNameId;
    }

    public Double getPercentage() {
        return percentage;
    }

    public void setPercentage(Double percentage) {
        this.percentage = percentage;
    }

    public Double getThickness() {
        return thickness;
    }

    public void setThickness(Double thickness) {
        this.thickness = thickness;
    }

    public Double getWidth() {
        return width;
    }

    public void setWidth(Double width) {
        this.width = width;
    }

    public Double getLength() {
        return length;
    }

    public void setLength(Double length) {
        this.length = length;
    }

    public String getDefectName() {
        return defectName;
    }

    public void setDefectName(String defectName) {
        this.defectName = defectName;
    }

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }
}
