package ru.crp.lvms.model.entities.effective.characteristics;

import com.fasterxml.jackson.annotation.JsonIgnore;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.managers.image.ImageFileContainer;
import ru.crp.lvms.model.entities.misc.AuditableImpl;
import ru.crp.lvms.validators.Unique;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import javax.validation.constraints.NotNull;

@Unique(entityClass = ECEntity.class, fieldName = "name", columnNane = "name", message = "Имя должно быть уникально")
@Table("effective_characteristics")
public class ECEntityTable extends AuditableImpl implements ImageFileContainer, Named {
    @NotNull(message = "Композиционный материал должен быть задан")
    @Column("composite_material_id")
    private Integer compositeMaterialId;

    @Column(value = "image_file_id", onlySelect = true)
    @JsonIgnore
    private Integer imageFileId;

    @Column("microstructure_file_id")
    private Integer microstructureFileId;

    @NotNull(message = "Имя должно быть задано")
    @GridColumn(name = "name", label = "Название", cell = GridColumnType.uri, order = 1)
    @Column("name")
    private String name;

    @GridColumn(name = "description", label = "Описание", cell = GridColumnType.string, order = 2)
    @Column("description")
    private String description;

    @Column("status_id")
    private int statusId;

    public Integer getCompositeMaterialId() {
        return compositeMaterialId;
    }

    public void setCompositeMaterialId(Integer compositeMaterialId) {
        this.compositeMaterialId = compositeMaterialId;
    }

    @Override
    public Integer getImageFileId() {
        return imageFileId;
    }

    public void setImageFileId(Integer imageFileId) {
        this.imageFileId = imageFileId;
    }

    public Integer getMicrostructureFileId() {
        return microstructureFileId;
    }

    public void setMicrostructureFileId(Integer microstructureFileId) {
        this.microstructureFileId = microstructureFileId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public int getStatusId() {
        return statusId;
    }

    public void setStatusId(int statusId) {
        this.statusId = statusId;
    }

}
