package ru.crp.lvms.model.entities.misc;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;
import ru.crp.lvms.web.dto.misc.Auditable;

import javax.annotation.Nullable;
import java.util.Date;

public class AuditableImpl implements Entity, Auditable {
    private int id;

    @GridColumn(name = "creationDate", label = "Создано", cell = GridColumnType.date, order = 100)
    @Column(value = "date_created", onlySelect = true)
    private Date creationDate;

    @GridColumn(name = "modificationDate", label = "Изменено", cell = GridColumnType.date, order = 101)
    @Column(value = "date_modified", onlySelect = true)
    private Date modificationDate;

    @Column("owner_id")
    private int ownerId;

    @Override
    public Date getCreationDate() {
        return creationDate != null ? new Date(creationDate.getTime()) : null;
    }

    @Override
    public void setCreationDate(@Nullable Date creationDate) {
        this.creationDate = creationDate != null ? new Date(creationDate.getTime()) : null;
    }

    public Date getModificationDate() {
        return modificationDate != null ? new Date(modificationDate.getTime()) : null;
    }

    public void setModificationDate(@Nullable Date modificationDate) {
        this.modificationDate = modificationDate != null ? new Date(modificationDate.getTime()) : null;
    }

    @Override
    public int getOwnerId() {
        return ownerId;
    }

    public void setOwnerId(int ownerId) {
        this.ownerId = ownerId;
    }

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }
}
