package ru.crp.lvms.model.entities.misc;

import java.util.EnumSet;
import java.util.Set;

public enum TreeType {
    materials,
    compositeMaterials,
    technologies,
    constructionElements,
    optimizations;

    public Set<ItemType> getTreeItemTypes() {
        switch (this) {
            case materials:
                return EnumSet.of(ItemType.Folder, ItemType.Material, ItemType.File);
            case compositeMaterials:
                return EnumSet.of(ItemType.Folder, ItemType.CompositeMaterial, ItemType.File);
            case technologies:
                return EnumSet.of(ItemType.Technology);
            case constructionElements:
                return EnumSet.of(ItemType.Folder, ItemType.ConstructionElement,
                        ItemType.File);
            case optimizations:
                return EnumSet.of(ItemType.Folder, ItemType.ConstructionElement);
            default:
                throw new IllegalArgumentException("Unexpected tree type: " + this);
        }
    }
}
