package ru.crp.lvms.model.entities.modfrontier;

import java.util.stream.Stream;

import static ru.crp.lvms.optimizations.mf.managers.MFDefaultParamsCreator.*;

public enum AlgorithmType {
    SIMPLEX(SIMPLEX_METHOD_ID),
    MOGA_II(MOGA_METHOD_ID),
    DOESequence(DOE_SEQUENCE_METHOD_ID);

    private int id;

    AlgorithmType(int id) {
        this.id = id;
    }

    public static AlgorithmType map(ParametersDictionary algorithm) {
        return Stream.of(values())
                .filter(val -> val.id == algorithm.getId())
                .findFirst()
                .orElseThrow(() -> new IllegalArgumentException("Unexpected algorithm id " + algorithm.getId()));
    }

    public int getId() {
        return id;
    }
}
