package ru.crp.lvms.model.entities.modfrontier;

import java.util.stream.Stream;

import static ru.crp.lvms.optimizations.mf.managers.MFDefaultParamsCreator.*;

public enum DoeType {
    Random(RANDOM_DOE_ID),
    Sobol(SOBOL_DOE_ID),
    ULH(ULH_DOE_ID);

    private int id;

    DoeType(int id) {

        this.id = id;
    }

    public static DoeType map(ParametersDictionary parametersDictionary) {
        return Stream.of(values())
                .filter(val -> val.id == parametersDictionary.getId())
                .findFirst()
                .orElseThrow(() -> new IllegalArgumentException("Unexpected parameters dictionary id " + parametersDictionary.getId()));
    }

    public int getId() {
        return id;
    }
}
