package ru.crp.lvms.model.entities.simulations;

import ru.crp.cmls.calculations.solvers.xml.config.Type;

import javax.annotation.Nonnull;

public enum SimulationType {
    Extension(1),
    Bend(2),
    Compression(3),
    ThermalExpansion(4),
    ThermalConductivityCoeff(5);


    private int id;
    private String displayName = "";

    SimulationType(int id) {
        this.id = id;
    }

    public String getDisplayName() {
        return displayName;
    }

    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }

    public int getId() {
        return id;
    }

    @Nonnull
    public static SimulationType valueOf(int id) {
        for (SimulationType type : values()) {
            if (type.getId() == id) {
                return type;
            }
        }
        throw new IllegalArgumentException("Enum value for id " + id + " is not found");
    }

    public Type toTaskType() {
        switch (this) {
            case Extension:
                return Type.vsTension;
            case Bend:
                return Type.vsBend;
            case Compression:
                return Type.vsCompression;
            case ThermalExpansion:
                return Type.vsThermalCalculation;
            case ThermalConductivityCoeff:
                return Type.vsThermalConductivityCalculation;
            default:
                throw new IllegalArgumentException("Unexpected enum value: " + this);
        }
    }
}
