package ru.crp.lvms.model.entities.technology;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.lvms.managers.image.ImageFileContainer;
import ru.crp.lvms.model.entities.EquipmentEntity;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import java.util.List;


@Table("technologies_join")
public class TechnologyEntity extends TechnologyEntityTable implements ImageFileContainer {
    private List<EquipmentEntity> equipments;

    public List<EquipmentEntity> getEquipments() {
        return equipments;
    }

    public void setEquipments(List<EquipmentEntity> equipments) {
        this.equipments = equipments;
    }

    @GridColumn(name = "descriptionFileName", label = "Файл описания", order = 4)
    @Column("descr_name")
    private String descriptionFileName;

    @Column("descr_source")
    private String descriptionFileSource;

    @GridColumn(name = "pathToImage", label = "Изображение", cell = GridColumnType.image, order = 5)
    private String pathToImage;

    @Column("image_source")
    private String imageFileSource;

    private String typeName;

    public String getDescriptionFileName() {
        return descriptionFileName;
    }

    public void setDescriptionFileName(String descriptionFileName) {
        this.descriptionFileName = descriptionFileName;
    }

    public String getDescriptionFileSource() {
        return descriptionFileSource;
    }

    public void setDescriptionFileSource(String descriptionFileSource) {
        this.descriptionFileSource = descriptionFileSource;
    }

    public String getPathToImage() {
        return pathToImage;
    }

    public void setPathToImage(String pathToImage) {
        this.pathToImage = pathToImage;
    }

    public String getImageFileSource() {
        return imageFileSource;
    }

    public void setImageFileSource(String imageFileSource) {
        this.imageFileSource = imageFileSource;
    }

    @Override
    public void setType(TechnologyType type) {
        super.setType(type);
        if (type == null) {
            typeName = null;
        } else {
            typeName = type.getDisplayName();
        }
    }

    public String getTypeName() {
        return typeName;
    }
}
