package ru.crp.lvms.model.entities.technology;

import com.fasterxml.jackson.annotation.JsonIgnore;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.model.entities.misc.BaseEntityTable;
import ru.crp.lvms.validators.Unique;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import javax.annotation.Nullable;
import javax.validation.constraints.NotNull;


@Table("technologies")
@Unique(entityClass = TechnologyEntity.class, fieldName = "name", columnNane = "name", message = "Имя должно быть уникально")
public class TechnologyEntityTable extends BaseEntityTable implements Named {
    @GridColumn(name = "name", label = "Название", cell = GridColumnType.uri, order = 1)
    @Column("name")
    @NotNull(message = "Название должно быть задано")
    private String name;

    @GridColumn(name = "lock", label = "Блок", order = 2)
    @Column("lock")
    private boolean lock;

    @Column(value = "image_file_id", onlySelect = true)
    @JsonIgnore
    private Integer imageFileId;

    @GridColumn(name = "videoUrl", label = "Ссылка на видео", order = 3)
    @Column("video_url")
    private String videoUrl;

    @Column("description_file_id")
    private Integer descriptionFileId;

    @Column("description")
    private String description;

    @NotNull(message = "Тип технологии должен быть задан")
    @Column("technology_type")
    private TechnologyType type;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public boolean isLock() {
        return lock;
    }

    public void setLock(boolean lock) {
        this.lock = lock;
    }

    public String getVideoUrl() {
        return videoUrl;
    }

    public void setVideoUrl(String videoUrl) {
        this.videoUrl = videoUrl;
    }

    public Integer getImageFileId() {
        return imageFileId;
    }

    public void setImageFileId(@Nullable Integer imageFileId) {
        this.imageFileId = imageFileId;
    }

    public Integer getDescriptionFileId() {
        return descriptionFileId;
    }

    public void setDescriptionFileId(@Nullable Integer descriptionFileId) {
        this.descriptionFileId = descriptionFileId;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public TechnologyType getType() {
        return type;
    }

    public void setType(TechnologyType type) {
        this.type = type;
    }
}
