package ru.crp.lvms.model.entities.technology;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.model.entities.misc.AuditableImpl;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import javax.validation.constraints.NotNull;


@Table("technology_simulations_ribs_parameters")
public class TechnologySimulationsRibsEntity implements Entity {

    private int id;

    @Column("position")
    private Integer position;

    @NotNull(message = "Положение x должно быть задано")
    @Column("origin_x")
    private Double origin_x;

    @NotNull(message = "Положение y должно быть задано")
    @Column("origin_y")
    private Double origin_y;

    @NotNull(message = "Угол должен быть задан")
    @Column("angle")
    private Double angle;

    @NotNull(message = "Шаг должен быть задан")
    @Column("steps")
    private String steps;


    @Column("technology_simulations_id")
    private Integer technologySimulationId;

    private final static String multiplicity = "1";

    private boolean massive;


    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public Integer getPosition() {
        return position;
    }

    public void setPosition(Integer position) {
        this.position = position;
    }

    public Double getOrigin_x() {
        return origin_x;
    }

    public void setOrigin_x(Double origin_x) {
        this.origin_x = origin_x;
    }

    public Double getOrigin_y() {
        return origin_y;
    }

    public void setOrigin_y(Double origin_y) {
        this.origin_y = origin_y;
    }

    public Double getAngle() {
        return angle;
    }

    public void setAngle(Double angle) {
        this.angle = angle;
    }

    public String getSteps() {
        return steps;
    }

    public void setSteps(String steps) {
        this.steps = steps;
    }

    public Integer getTechnologySimulationId() {
        return technologySimulationId;
    }

    public void setTechnologySimulationId(Integer technologySimulationId) {
        this.technologySimulationId = technologySimulationId;
    }

    public boolean isMassive() {
        return massive;
    }

    public void setMassive(boolean massive) {
        this.massive = massive;
    }

    public static String getMultiplicity() {
        return multiplicity;
    }
}
