package ru.crp.lvms.optimizations.base.dao;

import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Repository;
import ru.crp.lvms.model.dao.BaseSpaceDao;
import ru.crp.lvms.optimizations.base.entities.OptimizationReportEntity;

import java.util.List;
import java.util.Map;

@Repository
public class OptimizationReportDao extends BaseSpaceDao<OptimizationReportEntity> {

    public List<OptimizationReportEntity> findByOptimizationId(int optimizationId) {
        return find("WHERE optimization_id = ?", optimizationId);
    }

    public PageImpl<OptimizationReportEntity> findPageByOptimizationId(int id, Map<String, Object> filters, Pageable page) {
        return find("WHERE optimization_id = ?", filters, page, id);
    }
}
