package ru.crp.lvms.optimizations.base.entities;

import javax.annotation.Nullable;

public class OptimizationListSetting {
    private boolean isSelected;
    private boolean isCustom;
    private String value;
    @Nullable
    private Integer id;
    private String name;
    private String xmlName;

    public OptimizationListSetting() {
    }

    public OptimizationListSetting(boolean isSelected, Integer id, String name, String xmlName) {
        this.isSelected = isSelected;
        this.id = id;
        this.name = name;
        this.xmlName = xmlName;
        this.isCustom = false;
    }

    public OptimizationListSetting(boolean isSelected, String name, String xmlName) {
        this.isSelected = isSelected;
        this.name = name;
        this.xmlName = xmlName;
        this.isCustom = false;
    }

    public OptimizationListSetting(boolean isSelected, String name, String xmlName, boolean isCustom, String value) {
        this.isSelected = isSelected;
        this.name = name;
        this.xmlName = xmlName;
        this.isCustom = isCustom;
        this.value = value;
    }

    public boolean isSelected() {
        return isSelected;
    }

    public void setSelected(boolean selected) {
        isSelected = selected;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Nullable
    public Integer getId() {
        return id;
    }

    public void setId(@Nullable Integer id) {
        this.id = id;
    }

    public String getXmlName() {
        return xmlName;
    }

    public void setXmlName(String xmlName) {
        this.xmlName = xmlName;
    }

    public boolean isCustom() {
        return isCustom;
    }

    public void setCustom(boolean custom) {
        isCustom = custom;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        OptimizationListSetting that = (OptimizationListSetting) o;

        if (isSelected != that.isSelected) return false;
        if (isCustom != that.isCustom) return false;
        if (value != null ? !value.equals(that.value) : that.value != null) return false;
        if (id != null ? !id.equals(that.id) : that.id != null) return false;
        if (name != null ? !name.equals(that.name) : that.name != null) return false;
        return xmlName != null ? xmlName.equals(that.xmlName) : that.xmlName == null;

    }

    @Override
    public int hashCode() {
        int result = (isSelected ? 1 : 0);
        result = 31 * result + (isCustom ? 1 : 0);
        result = 31 * result + (value != null ? value.hashCode() : 0);
        result = 31 * result + (id != null ? id.hashCode() : 0);
        result = 31 * result + (name != null ? name.hashCode() : 0);
        result = 31 * result + (xmlName != null ? xmlName.hashCode() : 0);
        return result;
    }
}
