package ru.crp.lvms.optimizations.base.entities;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;

@Table("optimization_type_solver_combinations_join")
public class OptimizationTypeSolverCombination implements Entity {
    public static final String CAO_ID_COLUMN_NAME = "cao_id";
    public static final String CAE_ID_COLUMN_NAME = "cae_id";
    public static final String CAD_ID_COLUMN_NAME = "cad_id";
    public static final String OPTIMIZATION_TYPE_ID_COLUMN_NAME = "optimization_type_id";
    public static final String AVAILABLE_COLUMN_NAME = "available";

    private int id;

    @Column(CAO_ID_COLUMN_NAME)
    private Integer caoId;

    @Column("cao_name")
    private String caoName;

    @Column(CAE_ID_COLUMN_NAME)
    private Integer caeId;

    @Column("cae_name")
    private String caeName;

    @Column(CAD_ID_COLUMN_NAME)
    private Integer cadId;

    @Column("cad_name")
    private String cadName;

    @Column(OPTIMIZATION_TYPE_ID_COLUMN_NAME)
    private Integer optimizationTypeId;

    @Column("optimization_type_name")
    private String optimizationTypeName;

    @Column(AVAILABLE_COLUMN_NAME)
    private Boolean available;

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public Integer getCaoId() {
        return caoId;
    }

    public void setCaoId(Integer caoId) {
        this.caoId = caoId;
    }

    public Integer getCaeId() {
        return caeId;
    }

    public void setCaeId(Integer caeId) {
        this.caeId = caeId;
    }

    public Integer getCadId() {
        return cadId;
    }

    public void setCadId(Integer cadId) {
        this.cadId = cadId;
    }

    public Integer getOptimizationTypeId() {
        return optimizationTypeId;
    }

    public void setOptimizationTypeId(Integer optimizationTypeId) {
        this.optimizationTypeId = optimizationTypeId;
    }

    public Boolean getAvailable() {
        return available;
    }

    public void setAvailable(Boolean available) {
        this.available = available;
    }

    public String getCaoName() {
        return caoName;
    }

    public void setCaoName(String caoName) {
        this.caoName = caoName;
    }

    public String getCaeName() {
        return caeName;
    }

    public void setCaeName(String caeName) {
        this.caeName = caeName;
    }

    public String getCadName() {
        return cadName;
    }

    public void setCadName(String cadName) {
        this.cadName = cadName;
    }

    public String getOptimizationTypeName() {
        return optimizationTypeName;
    }

    public void setOptimizationTypeName(String optimizationTypeName) {
        this.optimizationTypeName = optimizationTypeName;
    }
}
