package ru.crp.lvms.optimizations.base.entities.tree;

import ru.crp.lvms.optimizations.base.entities.tree.TechnologicalConstraintTreeNodeValue;

import java.util.List;

public enum ConditionType {
    ALL_SELECTED((field, nodes, presentFields) -> nodes.stream().allMatch(presentFields::contains)),

    ANY_SELECTED((field, nodes, presentFields) -> nodes.stream().anyMatch(presentFields::contains)),

    NONE_SELECTED((field, nodes, presentFields) -> nodes.stream().noneMatch(presentFields::contains));


    private interface ConditionChecker {
        boolean satisfies(TechnologicalConstraintTreeNodeValue fieldToTest, List<Integer> nodes, List<Integer> presentFieldIds);
    }

    ConditionType(ConditionChecker conditionChecker) {
        this.conditionChecker = conditionChecker;
    }

    private ConditionChecker conditionChecker;

    public boolean satisfies(TechnologicalConstraintTreeNodeValue fieldToTest, List<Integer> nodes, List<Integer> presentFieldIds) {
        return conditionChecker.satisfies(fieldToTest, nodes, presentFieldIds);
    }
}
