package ru.crp.lvms.optimizations.base.enums;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;

import javax.annotation.Nonnull;
import java.util.Objects;

@JsonFormat(shape = JsonFormat.Shape.OBJECT)
public enum OptimizationCad implements OptimizationSolver {
    SolidWorks("SOLIDWORKS");

    private int id;

    private String uniqueName;

    OptimizationCad(String uniqueName) {
        this.uniqueName = uniqueName;
    }

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    @JsonIgnore
    public String getUniqueName() {
        return uniqueName;
    }

    public void setUniqueName(String uniqueName) {
        this.uniqueName = uniqueName;
    }

    @Nonnull
    public static OptimizationCad valueOf(Integer id) {
        for (OptimizationCad type : values()) {
            if (type.getId() == id) {
                return type;
            }
        }
        throw new IllegalArgumentException("There is no cad with such id: " + id);
    }

    @Nonnull
    public static OptimizationCad fromUniqueName(String uniqueName) {
        for (OptimizationCad type : values()) {
            if (Objects.equals(type.getUniqueName(), uniqueName)) {
                return type;
            }
        }
        throw new IllegalArgumentException("There is no cad with such unique name: " + uniqueName);
    }

    public String getName() {
        return this.name();
    }
}
