package ru.crp.lvms.optimizations.base.mappers;

import org.postgresql.jdbc4.Jdbc4Array;
import org.springframework.jdbc.core.RowMapper;
import ru.crp.lvms.model.entities.tasks.SlurmTaskInfo;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import static java.util.Arrays.asList;

public class SlurmTaskInfoRowMapper implements RowMapper<SlurmTaskInfo> {

    @Override
    public SlurmTaskInfo mapRow(ResultSet resultSet, int rowNum) throws SQLException {
        Jdbc4Array pgArray = (Jdbc4Array) resultSet.getArray("nodes");
        String[] nodes = new String[0];
        if (pgArray != null) {
            nodes = (String[]) pgArray.getArray();
        }
        SlurmTaskInfo slurmTaskInfo = new SlurmTaskInfo();
        slurmTaskInfo.setTaskId(resultSet.getInt("task_id"));
        slurmTaskInfo.setSlurmTaskId(resultSet.getInt("slurm_task_id"));
        slurmTaskInfo.setNodeNames(new ArrayList<>(asList(nodes)));
        slurmTaskInfo.setIsParallel(resultSet.getBoolean("is_parallel"));
        slurmTaskInfo.setNumOfNodes(resultSet.getInt("num_of_nodes"));

        return slurmTaskInfo;
    }
}
