package ru.crp.lvms.optimizations.mf.enums;

import javax.annotation.Nonnull;

public enum MFConstraintsType {
    NONE(4, ""),
    LESS(5, "1"),
    GREATER(6, "-1");

    private String xmlValue;
    private int id;

    MFConstraintsType(int id, String xmlValue) {
        this.xmlValue = xmlValue;
        this.id = id;
    }

    public String getXmlValue() {
        return xmlValue;
    }

    public int getId() {
        return id;
    }

    @Nonnull
    public static MFConstraintsType valueOf(int id) {
        for (MFConstraintsType constraint : values()) {
            if (constraint.getId() == id) {
                return constraint;
            }
        }
        throw new IllegalArgumentException("Enum value for id " + id + " is not found");
    }
}
