package ru.crp.lvms.optimizations.optimus.controllers;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import ru.crp.lvms.model.entities.misc.ParametersDictionaryType;
import ru.crp.lvms.model.entities.modfrontier.ParametersDictionary;
import ru.crp.lvms.optimizations.base.managers.OptimizationManager;
import ru.crp.lvms.optimizations.optimus.managers.OptimusOptimizationSettingsManager;
import ru.crp.lvms.security.CurrentUser;
import ru.crp.lvms.security.PortalUser;

import java.util.List;

import static ru.crp.lvms.utils.URLs.OPTIMUS_SUGGEST_URL;

@RestController
@RequestMapping(value = OPTIMUS_SUGGEST_URL, produces = MediaType.APPLICATION_JSON_VALUE)
public class OptimusSuggestController {
    @Autowired
    private OptimusOptimizationSettingsManager optimusOptimizationSettingsManager;

    @Autowired
    private OptimizationManager optimizationManager;

    @RequestMapping(value = "/targetFunctions/types", method = RequestMethod.GET)
    public List<ParametersDictionary> getTargetFunctions(@CurrentUser PortalUser currentUser) {
        return optimusOptimizationSettingsManager.findByTypeName(ParametersDictionaryType.TargetFunction);
    }

    @RequestMapping(value = "/constraints/types", method = RequestMethod.GET)
    public List<ParametersDictionary> getConstraints(@CurrentUser PortalUser currentUser) {
        return optimusOptimizationSettingsManager.findByTypeName(ParametersDictionaryType.Constraint);
    }
}
