package ru.crp.lvms.optimizations.optimus.enums;

import ru.crp.lvms.model.entities.modfrontier.ParametersDictionary;

import java.util.stream.Stream;

import static ru.crp.lvms.optimizations.optimus.managers.OptimusDefaultParamsCreator.*;

public enum OptimusDoeType {
    LATIN(LATIN_DOE_ID),
    RANDOM(RANDOM_DOE_ID);

    private int id;

    OptimusDoeType(int id) {

        this.id = id;
    }

    public static OptimusDoeType map(ParametersDictionary parametersDictionary) {
        return Stream.of(values())
                .filter(val -> val.id == parametersDictionary.getId())
                .findFirst()
                .orElseThrow(() -> new IllegalArgumentException("Unexpected parameters dictionary id " + parametersDictionary.getId()));
    }

    public int getId() {
        return id;
    }
}
