package ru.crp.lvms.optimizations.optimus.tpl;

import org.apache.commons.lang3.text.StrSubstitutor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import ru.crp.lvms.optimizations.base.entities.OptimizationEntity;
import ru.crp.lvms.optimizations.optimus.dao.OptimusOptimizationBaseSettingsDao;
import ru.crp.lvms.optimizations.optimus.entities.OptimusOptimizationBaseSetting;
import ru.crp.lvms.optimizations.optimus.enums.OptimusBaseSettingType;
import ru.crp.lvms.optimizations.optimus.managers.OptimusOptimizationSettingsManager;
import ru.crp.lvms.optimizations.optistruct.dao.*;
import ru.crp.lvms.optimizations.optistruct.entities.*;
import ru.crp.lvms.optimizations.optistruct.enums.OptistructBaseSettingType;
import ru.crp.lvms.optimizations.optistruct.enums.OptistructSettingsType;
import ru.crp.lvms.optimizations.optistruct.managers.OptistructOptimizationSettingsManager;
import ru.crp.lvms.optimizations.optistruct.tcl.OptistructFemScriptGenerator;
import ru.crp.lvms.utils.NumericalInputConverter;

import javax.xml.bind.JAXBException;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

import static java.util.Arrays.asList;
import static java.util.stream.Collectors.toList;
import static org.apache.commons.lang3.StringUtils.isEmpty;
import static ru.crp.lvms.optimizations.optistruct.managers.OptistructAdditionalParametersManager.PLAIN_TYPE_ID;
import static ru.crp.lvms.utils.Utils.zipWithIndex;

@Component
public class OptimusTemplateGenerator {

    @Autowired
    private OptimusOptimizationSettingsManager optimusOptimizationSettingsManager;

    public Path generateConfig(OptimizationEntity optimization) throws IOException, JAXBException {
        Path tempConfigFile = Files.createTempFile(null, null);
        Map<OptimusBaseSettingType, OptimusOptimizationBaseSetting> baseSettings = optimusOptimizationSettingsManager.findBaseSettings(optimization.getId(),null);
        String data = IntStream.range(1,baseSettings.get(OptimusBaseSettingType.NUM_CAO_VARYING_PARAMS).getCurrentValue()+1)
                .mapToObj(i -> "par"+String.valueOf(i)+ "=" + "$par" + String.valueOf(i) +"$")
                .collect(Collectors.joining("\n"));
        Files.write(tempConfigFile, data.getBytes());
        return tempConfigFile;
    }
}
