package ru.crp.lvms.optimizations.optistruct.dao;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettignsDao;
import ru.crp.lvms.optimizations.optistruct.entities.OptistructLnSet;

import java.util.ArrayList;
import java.util.List;

@Repository
public class OptistructOptimizationLnSetDao extends AbstractOptimizationSettignsDao<OptistructLnSet> {
    public List<OptistructLnSet> findSelectedLnSets(Integer optimizationId, Integer lnSetTypeId) {
        if (lnSetTypeId == null) {
            return find("WHERE optimization_id = ? AND is_selected = TRUE ORDER BY name", optimizationId);
        } else {
            return find("WHERE optimization_id = ? AND is_selected = TRUE AND lnset_type_id = ? ORDER BY name", optimizationId, lnSetTypeId);
        }
    }

    public void deleteAllForOptimization(Integer optimizationId) {
        jdbcTemplate().update("DELETE FROM " + getTableName() + " WHERE optimization_id = ?", optimizationId);
    }

    public void addLnSetsForOptimization(Integer optimizationId, List<OptistructLnSet> newLnSets) {
        List<Object[]> paramsInsert = new ArrayList<>();
        for (OptistructLnSet lnset : newLnSets) {
            paramsInsert.add(new Object[]{
                    optimizationId,
                    lnset.getName(),
                    lnset.getLnSetTypeId(),
                    lnset.getIsSelected()
            });
        }
        if (!paramsInsert.isEmpty()) {
            getJdbcTemplate().batchUpdate(
                    "INSERT INTO " + getTableName() +
                            "(optimization_id," +
                            " name," +
                            " lnset_type_id," +
                            " is_selected) " +
                            "VALUES (?, ?, ?, ?)",
                    paramsInsert);
        }
    }
}
