package ru.crp.lvms.optimizations.optistruct.entities;


import com.fasterxml.jackson.annotation.JsonFormat;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettings;
import ru.crp.lvms.optimizations.optistruct.enums.OptistructLoadStepCalculationType;

import java.util.ArrayList;
import java.util.List;

@Table("optistruct_optimization_load_steps_join")
public class OptistructOptimizationLoadStep extends AbstractOptimizationSettings {

    @Column("script_id")
    private Integer scriptId;

    @Column("is_fixed")
    private Boolean isFixed;

    @Column("calculation_type")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private OptistructLoadStepCalculationType calculationType;

    // selected_load_ids; intentionally without annotation, dao has custom row mapper
    private List<Integer> selectedLoadIds;

    public OptistructOptimizationLoadStep() {
        selectedLoadIds = new ArrayList<>();
    }

    public Integer getScriptId() {
        return scriptId;
    }

    public void setScriptId(Integer scriptId) {
        this.scriptId = scriptId;
    }

    public Boolean getIsFixed() {
        return isFixed;
    }

    public void setIsFixed(Boolean fixed) {
        isFixed = fixed;
    }

    public OptistructLoadStepCalculationType getCalculationType() {
        return calculationType;
    }

    public void setCalculationType(OptistructLoadStepCalculationType calculationType) {
        this.calculationType = calculationType;
    }

    public List<Integer> getSelectedLoadIds() {
        return selectedLoadIds;
    }

    public void setSelectedLoadIds(List<Integer> selectedLoadIds) {
        if (selectedLoadIds == null) {
            this.selectedLoadIds = new ArrayList<>();
        } else {
            this.selectedLoadIds = selectedLoadIds;
        }
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        OptistructOptimizationLoadStep that = (OptistructOptimizationLoadStep) o;

        return getScriptId().equals(that.getScriptId());
    }

    @Override
    public int hashCode() {
        return getScriptId().hashCode();
    }
}
