package ru.crp.lvms.optimizations.optistruct.enums;

import com.fasterxml.jackson.annotation.JsonFormat;

import javax.annotation.Nonnull;

@JsonFormat(shape = JsonFormat.Shape.OBJECT)
public enum ComponentType {
    PSHELL(1),
    PSOLID(2),
    PCOMP(3),
    PBAR(4),
    PROD(5),
    PBARL(6),
    PBEAM(7),
    PBEAML(8);

    private int id;

    ComponentType(int id) {
        this.id = id;
    }

    @Nonnull
    public static ComponentType valueOf(int id) {
        for (ComponentType cur : values()) {
            if (cur.getId() == id) {
                return cur;
            }
        }
        throw new IllegalArgumentException("Enum value for id " + id + " is not found");
    }

    public int getId() {
        return id;
    }

    public String getName() {
        return this.toString();
    }
}
