package ru.crp.lvms.optimizations.optistruct.enums;

import static ru.crp.lvms.tasks.fileGenerators.ToscaInputFileGenerator.ABAQUS_CAE_FILE_EXT;
import static ru.crp.lvms.tasks.fileGenerators.ToscaInputFileGenerator.ANSYS_CAE_FILE_EXT;

public enum OptistructConvertDirection {
    abaqusToOptistruct, ansysToOptistruct, optistructToAnsys, optistructToAbaqus;

    public OptistructConvertDirection backward() {
        switch (this) {
            case abaqusToOptistruct:
                return optistructToAbaqus;
            case ansysToOptistruct:
                return optistructToAnsys;
            case optistructToAnsys:
                return ansysToOptistruct;
            case optistructToAbaqus:
            default:
                return abaqusToOptistruct;
        }
    }

    public static OptistructConvertDirection fromExtension(String fileName) {
        if (fileName.endsWith(ANSYS_CAE_FILE_EXT)) {
            return OptistructConvertDirection.ansysToOptistruct;
        } else if (fileName.endsWith(ABAQUS_CAE_FILE_EXT)) {
            return OptistructConvertDirection.abaqusToOptistruct;
        } else {
            throw new IllegalArgumentException("Не удалось определить тип файла оптимизации из его расширения: " + fileName);
        }
    }
}
