package ru.crp.lvms.optimizations.optistruct.tcl;

import org.springframework.stereotype.Component;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;

@Component
public class OptistructBatchGenerator {

    public static final String CONVERT_TO_STARTER = "\"OPTISTRUCT_TCL_STARTER1\" -tcl INPUT_FILES_PATH/";
    public static final String GENERATE_FEM_STARTER = "\"OPTISTRUCT_TCL_STARTER2\" -tcl INPUT_FILES_PATH/";
    public static final String START_OPTIMIZATION = "cmd /c \"OPTISTRUCT_TCL_STARTER3\" INPUT_FILES_PATH/";
    public static final String OSS_STARTER = "\"OPTISTRUCT_TCL_STARTER2\" -tcl INPUT_FILES_PATH/";
    public static final String CONVERT_FROM_STARTER = "\"OPTISTRUCT_TCL_STARTER1\" -tcl INPUT_FILES_PATH/";

    public Path generateConfig(String generateFEMFileName, String OSSFileName,
                               String convertFromFileName) throws IOException {
        Path tempConfigFile = Files.createTempFile(null, null);
        StringBuilder content = new StringBuilder();
        content.append(GENERATE_FEM_STARTER + generateFEMFileName + "\n");
        content.append(START_OPTIMIZATION + "file_name2.fem\n");
        content.append(OSS_STARTER + OSSFileName + "\n");
        content.append(CONVERT_FROM_STARTER + convertFromFileName + "\n");

        Files.write(tempConfigFile, content.toString().getBytes());
        return tempConfigFile;
    }

    public Path generateConfig(String convertToFileName) throws IOException {
        Path tempConfigFile = Files.createTempFile(null, null);
        StringBuilder content = new StringBuilder();
        content.append(CONVERT_TO_STARTER + convertToFileName + "\n");
        Files.write(tempConfigFile, content.toString().getBytes());
        return tempConfigFile;
    }

}
