package ru.crp.lvms.optimizations.tosca.config.argumentConverters;

import org.apache.commons.lang3.tuple.Pair;
import ru.crp.lvms.optimizations.base.entities.tree.TechnologicalConstraintTreeNodeValue;
import ru.crp.lvms.optimizations.tosca.entities.ToscaOptimizationTechnologicalConstraint;
import ru.crp.lvms.optimizations.tosca.managers.ToscaOptimizationTechnologicalConstraintManager;

import java.util.Collections;
import java.util.List;

import static com.google.common.primitives.Ints.asList;

public class IgnoreArgumentsConverter extends CommandArgumentConverter{
    // SPACE_DIR_SETTINGS
    private static final List<Integer> ARGUMETS_TO_IGNORE_IDS = asList(93);

    public IgnoreArgumentsConverter(ToscaOptimizationTechnologicalConstraintManager toscaOptimizationTechnologicalConstraintManager) {
        super(toscaOptimizationTechnologicalConstraintManager);
    }

    @Override
    public List<Pair<String, String>> convertValue(ToscaOptimizationTechnologicalConstraint constraint, TechnologicalConstraintTreeNodeValue value, List<TechnologicalConstraintTreeNodeValue> allValues, List<Pair<String, String>> alreadyConvertedValues) {
        return Collections.emptyList();
    }

    @Override
    public boolean canConvert(ToscaOptimizationTechnologicalConstraint constraint, TechnologicalConstraintTreeNodeValue value) {
        return ARGUMETS_TO_IGNORE_IDS.contains(value.getTechnologicalConstraintTreeId());
    }
}
