package ru.crp.lvms.optimizations.tosca.config.commandConverters;

import org.apache.commons.lang3.tuple.Pair;
import ru.crp.lvms.optimizations.tosca.config.Command;
import ru.crp.lvms.optimizations.tosca.config.OptimizationTypeParameters;
import ru.crp.lvms.optimizations.tosca.entities.ToscaOptimizationTechnologicalConstraint;
import ru.crp.lvms.optimizations.base.entities.tree.TechnologicalConstraintTreeNodeValue;
import ru.crp.lvms.optimizations.tosca.managers.ToscaOptimizationTechnologicalConstraintManager;

import java.util.List;
import java.util.stream.Stream;

public class SymmetryConditionCommandConverter extends CommandConverter {
    public SymmetryConditionCommandConverter(ToscaOptimizationTechnologicalConstraintManager toscaOptimizationTechnologicalConstraintManager) {
        super(toscaOptimizationTechnologicalConstraintManager);
    }

    @Override
    public Stream<Command> convert(OptimizationTypeParameters typeParameters, ToscaOptimizationTechnologicalConstraint tc, Integer index, String space, List<TechnologicalConstraintTreeNodeValue> values) {
        List<Pair<String, String>> commandArguments = convertTCValues(tc, values);

        Command linkCommand = new Command("LINK" + typeParameters.getDvName())
                .addParameter("ID_NAME", LINK_ID_PREFIX + index)
                .addParameters(commandArguments);

        Command dvconCommand = createDvConCommand(typeParameters, tc, index)
                .addParameter(typeParameters.getGroupName(), space)
                .addParameter("CHECK_LINK", LINK_ID_PREFIX + index);

        return Stream.of(linkCommand, dvconCommand);
    }


    @Override
    public boolean canConvert(ToscaOptimizationTechnologicalConstraint tc) {
        return tc.getTechnologicalConstraintId() == SYMMETRY_CONDITION_TC_ID;
    }
}
