package ru.crp.lvms.optimizations.tosca.controllers;

import org.springframework.beans.factory.annotation.Autowired;
import ru.crp.lvms.optimizations.base.enums.OptimizationCao;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettings;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettingsController;
import ru.crp.lvms.optimizations.tosca.enums.ToscaBaseSettingType;
import ru.crp.lvms.optimizations.tosca.enums.ToscaSettingsType;
import ru.crp.lvms.optimizations.tosca.managers.ToscaOptimizationSettingsManager;

public abstract class ToscaAbstractOptimizationSettingsController<T extends AbstractOptimizationSettings>
        extends AbstractOptimizationSettingsController<T, ToscaSettingsType> {

    @Autowired
    private ToscaOptimizationSettingsManager toscaOptimizationSettingsManager;

    protected abstract ToscaBaseSettingType getToskaOptimizationBaseSettingType();

    @Override
    protected Integer getSettingsCount(int optimizationId) {
        return toscaOptimizationSettingsManager
                .getBaseSettingsByType(optimizationId, getToskaOptimizationBaseSettingType())
                .getCurrentValue();
    }

    @Override
    protected ToscaOptimizationSettingsManager getSettingsManager() {
        return toscaOptimizationSettingsManager;
    }

    @Override
    protected OptimizationCao getOptimizationSolverType() {
        return OptimizationCao.Tosca;
    }
}
