package ru.crp.lvms.optimizations.tosca.dao;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettignsDao;
import ru.crp.lvms.optimizations.tosca.entities.ToscaOptimizationBaseSetting;
import ru.crp.lvms.optimizations.tosca.enums.ToscaBaseSettingType;

import javax.annotation.PostConstruct;

@Repository
public class ToscaOptimizationBaseSettingsDao extends AbstractOptimizationSettignsDao<ToscaOptimizationBaseSetting> {

    @PostConstruct
    private void init() {
        getJdbcTemplate().query("SELECT id, max_value, min_value, display_name FROM toska_optimization_base_setting_types", rs -> {
            ToscaBaseSettingType type = ToscaBaseSettingType.valueOf(rs.getInt("id"));
            type.setMaxValue(rs.getInt("max_value"));
            type.setDisplayName(rs.getString("display_name"));
            type.setMinValue(rs.getInt("min_value"));
        });
    }

    public ToscaOptimizationBaseSetting getBaseSettingsByType(int optimizationId, int typeId) {
        return findOne("WHERE optimization_id = ? AND type_id = ?", optimizationId, typeId);
    }
}
