package ru.crp.lvms.optimizations.tosca.entities;

import com.fasterxml.jackson.annotation.JsonIgnore;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettings;

@Table("toska_technological_constraints_join")
public class ToscaOptimizationTechnologicalConstraint extends AbstractOptimizationSettings {

    @Column("constraint_id")
    private Integer technologicalConstraintId;

    @Column(value = "constraint_name", onlySelect = true)
    private String constraintName;

    @JsonIgnore
    @Column(value = "comand_name", onlySelect = true)
    private String comandName;

    @Column("set_id")
    private Integer setId;

    public Integer getSetId() {
        return setId;
    }

    public void setSetId(Integer setId) {
        this.setId = setId;
    }

    public String getComandName() {
        return comandName;
    }

    public void setComandName(String comandName) {
        this.comandName = comandName;
    }

    public ToscaOptimizationTechnologicalConstraint() {
    }

    public ToscaOptimizationTechnologicalConstraint(int newOptimizationId, int defaultParameterId, String name) {
        setOptimizationId(newOptimizationId);
        setTechnologicalConstraintId(defaultParameterId);
        setName(name);
    }

    public Integer getTechnologicalConstraintId() {
        return technologicalConstraintId;
    }

    public void setTechnologicalConstraintId(Integer technologicalConstraintId) {
        this.technologicalConstraintId = technologicalConstraintId;
    }

    public String getConstraintName() {
        return constraintName;
    }

    public void setConstraintName(String constraintName) {
        this.constraintName = constraintName;
    }
}
