package ru.crp.lvms.optimizations.tosca.entities;

import com.fasterxml.jackson.annotation.JsonFormat;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettings;
import ru.crp.lvms.optimizations.tosca.enums.SetType;

@Table("toska_sets_join")
public class ToscaSet extends AbstractOptimizationSettings {

    @Column("is_optimization_space")
    private boolean isOptimizationSpace;

    @Column("set_type_id")
    private Integer setTypeId;

    @JsonFormat(shape = JsonFormat.Shape.STRING)
    @Column("set_type_name")
    private SetType setTypeName;

    @Column("is_selected")
    private boolean isSelected;

    public ToscaSet(int newOptimizationId, SetType setTypeName, String name) {
        setOptimizationId(newOptimizationId);
        this.isOptimizationSpace = false;
        this.setTypeName = setTypeName;
        this.setTypeId = setTypeName.getId();
        this.isSelected = false;
        this.setName(name);
    }

    public ToscaSet() {
    }

    public boolean getIsOptimizationSpace() {
        return isOptimizationSpace;
    }

    public void setIsOptimizationSpace(boolean optimizationSpace) {
        isOptimizationSpace = optimizationSpace;
    }

    public Integer getSetTypeId() {
        return setTypeId;
    }

    public void setSetTypeId(Integer setTypeId) {
        this.setTypeId = setTypeId;
    }

    public SetType getSetTypeName() {
        return setTypeName;
    }

    public void setSetTypeName(SetType setTypeName) {
        this.setTypeName = setTypeName;
    }

    public boolean getIsSelected() {
        return isSelected;
    }

    public void setIsSelected(boolean selected) {
        isSelected = selected;
    }
}
