package ru.crp.lvms.pdf.reports.vo;

import ru.crp.lvms.model.entities.effective.characteristics.ECDefectEntity;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name = "defect")
@XmlAccessorType(XmlAccessType.FIELD)
public class Defect {
    private String name;
    private String perc;
    private String thic;
    private String wid;
    private String len;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPerc() {
        return perc;
    }

    public void setPerc(String perc) {
        this.perc = perc;
    }

    public String getThic() {
        return thic;
    }

    public void setThic(String thic) {
        this.thic = thic;
    }

    public String getWid() {
        return wid;
    }

    public void setWid(String wid) {
        this.wid = wid;
    }

    public String getLen() {
        return len;
    }

    public void setLen(String len) {
        this.len = len;
    }

    public static Defect fromECDefectEntity(ECDefectEntity ecDefectEntity) {
        Defect result = new Defect();
        result.setName(ecDefectEntity.getDefectName());
        result.setPerc(ecDefectEntity.getPercentage() + "");
        result.setThic(ecDefectEntity.getThickness() + "");
        result.setWid(ecDefectEntity.getWidth() + "");
        result.setLen(ecDefectEntity.getLength() + "");
        return result;
    }
}
