package ru.crp.lvms.tasks;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.crp.lvms.cluster.model.ClusterEntity;
import ru.crp.lvms.model.entities.tasks.TaskEntity;
import ru.crp.lvms.tasks.misc.BaseTasksJob;
import ru.crp.lvms.tasks.misc.ClusterCommandsManager;

import java.util.List;

@Component("checkTasksStatusJob")
public class CheckTaskStatusJob extends BaseTasksJob {
    private static final Logger LOGGER = LoggerFactory.getLogger(CheckTaskStatusJob.class);

    @Override
    @Transactional(readOnly = true)
    public List<TaskEntity> getTasksToCheck() {
        return taskDao.findTasksForCheckingStatus();
    }

    @Override
    public void checkTask(TaskEntity taskToCheck, ClusterEntity taskCluster, ClusterCommandsManager clusterCommandManager) throws Exception {
        if (!clusterCommandManager.isTaskReadyForCheck(taskToCheck, taskCluster)) {
            return;
        }
        clusterCommandManager.checkTaskStatus(taskToCheck);
    }
}
