package ru.crp.lvms.tasks.slurm;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.crp.lvms.cluster.model.ClusterType;
import ru.crp.lvms.tasks.misc.BaseTaskCommand;
import ru.crp.lvms.tasks.misc.BaseTaskCommandCallback;
import ru.crp.lvms.tasks.misc.ClusterCommandsManager;
import ru.crp.lvms.tasks.slurm.callbacks.SlurmCancelTaskCommandCallback;
import ru.crp.lvms.tasks.slurm.callbacks.SlurmCheckTaskCommandCallback;
import ru.crp.lvms.tasks.slurm.callbacks.SlurmDownloadResultsCommandCallback;
import ru.crp.lvms.tasks.slurm.callbacks.SlurmStartTaskCommandCallback;
import ru.crp.lvms.tasks.slurm.commands.SlurmCancelTaskCommand;
import ru.crp.lvms.tasks.slurm.commands.SlurmCheckTaskCommand;
import ru.crp.lvms.tasks.slurm.commands.SlurmDownloadResultsCommand;
import ru.crp.lvms.tasks.slurm.commands.SlurmStartTaskCommand;

@Service
public class SlurmClusterCommandsManager implements ClusterCommandsManager {
    @Autowired
    private SlurmStartTaskCommand slurmStartTaskCommand;
    @Autowired
    private SlurmStartTaskCommandCallback slurmStartTaskCommandCallback;

    @Autowired
    private SlurmCheckTaskCommand slurmCheckTaskCommand;
    @Autowired
    private SlurmCheckTaskCommandCallback slurmCheckTaskCommandCallback;

    @Autowired
    private SlurmDownloadResultsCommand slurmDownloadResultsCommand;
    @Autowired
    private SlurmDownloadResultsCommandCallback slurmDownloadResultsCommandCallback;

    @Autowired
    private SlurmCancelTaskCommand slurmCancelTaskCommand;
    @Autowired
    private SlurmCancelTaskCommandCallback slurmCancelTaskCommandCallback;

    @Override
    public ClusterType getClusterType() {
        return ClusterType.Slurm;
    }

    @Override
    public BaseTaskCommand<?, ?> getStartCommand() {
        return slurmStartTaskCommand;
    }

    @Override
    public BaseTaskCommandCallback<?> getStartCommandCallback() {
        return slurmStartTaskCommandCallback;
    }

    @Override
    public BaseTaskCommand<?, ?> getCheckCommand() {
        return slurmCheckTaskCommand;
    }

    @Override
    public BaseTaskCommandCallback<?> getCheckCommandCallback() {
        return slurmCheckTaskCommandCallback;
    }

    @Override
    public BaseTaskCommand<?, ?> getDownloadResultsCommand() {
        return slurmDownloadResultsCommand;
    }

    @Override
    public BaseTaskCommandCallback<?> getDownloadResultsCommandCallback() {
        return slurmDownloadResultsCommandCallback;
    }

    @Override
    public BaseTaskCommand<?, ?> getCancelCommand() {
        return slurmCancelTaskCommand;
    }

    @Override
    public BaseTaskCommandCallback<?> getCancelCommandCallback() {
        return slurmCancelTaskCommandCallback;
    }

}
