package ru.crp.lvms.tasks.slurm.callbacks;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import ru.crp.cmlb.model.entities.CalculationStatus;
import ru.crp.lvms.model.entities.tasks.TaskEntity;
import ru.crp.lvms.tasks.misc.BaseTaskCommandCallback;

@Service
public class SlurmCheckTaskCommandCallback extends BaseTaskCommandCallback<Void> {
    private static final Logger LOGGER = LoggerFactory.getLogger(SlurmCheckTaskCommandCallback.class);

    @Override
    public void onSuccess(TaskEntity task, Object unused) {
        LOGGER.info("Updated task {} state. New state is '{}'", task.getId(), CalculationStatus.valueOf(task.getStatusId()));
    }

    @Override
    public void onFailure(TaskEntity task, Throwable error) {
        LOGGER.error("Exception while checking state for task {}", task.getId(), error);
    }
}
