package ru.crp.lvms.tasks.slurm.requests;

import java.util.List;
import java.util.stream.Stream;

import static java.util.stream.Collectors.toList;

public class ObjectNamesRequest extends AbstractRequest<List<String>> {
    private String commandLine;

    public ObjectNamesRequest(String commandLine) {
        this.commandLine = commandLine;
    }

    @Override
    public String getCommandLine() {
        return commandLine;
    }

    @Override
    public List<String> parseResponse(String response) {
        return Stream.of(response.split("\n"))
                .map(objectInfo -> objectInfo.split(" +")[0].trim())
                .collect(toList());
    }

    public static ObjectNamesRequest createNodesListCommand() {
        return new ObjectNamesRequest("sinfo -Nh");
    }

    public static ObjectNamesRequest createTasksListCommand() {
        return new ObjectNamesRequest("squeue -rh -o %A");
    }
}
