package ru.crp.lvms.tasks.space;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.crp.lvms.cluster.model.ClusterType;
import ru.crp.lvms.tasks.space.callbacks.SpaceCheckTaskCommandCallback;
import ru.crp.lvms.tasks.space.callbacks.SpaceDownloadResultsCommandCallback;
import ru.crp.lvms.tasks.space.callbacks.SpaceStartTaskCommandCallback;
import ru.crp.lvms.tasks.misc.BaseTaskCommand;
import ru.crp.lvms.tasks.misc.BaseTaskCommandCallback;
import ru.crp.lvms.tasks.misc.ClusterCommandsManager;
import ru.crp.lvms.tasks.space.commands.SpaceCancelTaskCommand;
import ru.crp.lvms.tasks.space.commands.SpaceCheckTaskCommand;
import ru.crp.lvms.tasks.space.commands.SpaceDownloadResultsCommand;
import ru.crp.lvms.tasks.space.commands.SpaceStartTaskCommand;

@Service
public class BenchClusterCommandsManager implements ClusterCommandsManager {
    @Autowired
    private SpaceStartTaskCommand spaceStartTaskCommand;
    @Autowired
    private SpaceStartTaskCommandCallback spaceStartTaskCommandCallback;

    @Autowired
    private SpaceCheckTaskCommand spaceCheckTaskCommand;
    @Autowired
    private SpaceCheckTaskCommandCallback spaceCheckTaskCommandCallback;

    @Autowired
    private SpaceDownloadResultsCommand spaceDownloadResultsCommand;
    @Autowired
    private SpaceDownloadResultsCommandCallback spaceDownloadResultsCommandCallback;

    @Autowired
    private SpaceCancelTaskCommand spaceCancelTaskCommand;

    @Override
    public ClusterType getClusterType() {
        return ClusterType.Space;
    }

    @Override
    public BaseTaskCommand<?, ?> getStartCommand() {
        return spaceStartTaskCommand;
    }

    @Override
    public BaseTaskCommandCallback<?> getStartCommandCallback() {
        return spaceStartTaskCommandCallback;
    }

    @Override
    public BaseTaskCommand<?, ?> getCheckCommand() {
        return spaceCheckTaskCommand;
    }

    @Override
    public BaseTaskCommandCallback<?> getCheckCommandCallback() {
        return spaceCheckTaskCommandCallback;
    }

    @Override
    public BaseTaskCommand<?, ?> getDownloadResultsCommand() {
        return spaceDownloadResultsCommand;
    }

    @Override
    public BaseTaskCommandCallback<?> getDownloadResultsCommandCallback() {
        return spaceDownloadResultsCommandCallback;
    }

    @Override
    public BaseTaskCommand<?, ?> getCancelCommand() {
        return spaceCancelTaskCommand;
    }

    @Override
    public BaseTaskCommandCallback<?> getCancelCommandCallback() {
        return null;
    }
}
