package ru.crp.lvms.tasks.space.commands;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.AsyncResult;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.concurrent.ListenableFuture;
import ru.crp.cmlb.model.entities.CalculationStatus;
import ru.crp.lvms.managers.tasks.TaskManager;
import ru.crp.lvms.model.entities.tasks.TaskEntity;
import ru.crp.lvms.tasks.misc.BaseTaskCommand;

@Component
public class SpaceCancelTaskCommand extends BaseTaskCommand<Void, Void> {

    @Autowired
    private TaskManager taskManager;

    // intentionally synchronous to support legacy API. todo change it
    @Transactional
    @Override
    public ListenableFuture<Void> processTask(TaskEntity task, Object unused) throws Exception {
        if (task.getStatusId() != CalculationStatus.Waiting.getId()) {
            throw new IllegalArgumentException(String.format("Trying to stop task %d cancel state '%s'", task.getId(), task.getStatus()));
        }
        taskStatusUpdater.changeTaskStatus(task, CalculationStatus.Canceled);
        return new AsyncResult<>(null);
    }
}
