package ru.crp.lvms.utils;

import javax.servlet.http.HttpServletRequest;

public final class URLs {
    public static final String MATERIALS_URL = "/materials";
    public static final String USERS_URL = "/users";
    public static final String USER_AVATAR_URL = "/users/{id}/avatar";
    public static final String PARAMETERS_URL = "/parameters";
    public static final String COMPOSITE_MATERIALS_URL = "/compositeMaterials";
    public static final String NODES_URL = "/nodes";

    public static final String TECHNOLOGY_URL = "/technologies";
    public static final String TECHNOLOGY_PARAMETERS_URL = TECHNOLOGY_URL + "/{technologyId}/parameters";
    public static final String POSSIBLE_DEFECTS_URL = TECHNOLOGY_URL + "/{technologyId}/defects";
    public static final String TECHNOLOGY_MATERIALS_URL = TECHNOLOGY_URL + "/{technologyId}/compositeMaterials";
    public static final String EQUIPMENT_URL = TECHNOLOGY_URL + "/{technologyId}/equipments";
    public static final String TECHNOLOGY_SIMULATIONS_URL = "/technologySimulations";

    public static final String CONSTRUCTION_ELEMENTS_URL = "/constructionElements";

    public static final String TREE_URL = "/tree";
    public static final String STANDARDS_URL = "/standards";
    public static final String TASKS_URL = "/tasks";
    public static final String TASKS_QUEUE_URL = "/tasksQueue";
    public static final String SIMULATIONS_URL = "/simulations";
    public static final String OPTIMIZATION_TYPES_URL = "/optimizationTypes";

    public static final String MATERIAL_FILES_BASE_URL = "/materialFiles";
    public static final String MATERIAL_FILES_URL = MATERIALS_URL + "/{materialId}/materialFiles";
    public static final String COMPOSITE_MATERIAL_FILES_URL = COMPOSITE_MATERIALS_URL + "/{materialId}/materialFiles";

    public static final String EFFECTIVE_CHARACTERISTICS_URL = "/effectiveCharacteristics";

    public static final String SINGLE_MATERIAL_URL = MATERIALS_URL + "/{materialId}";
    public static final String SINGLE_COMPOSITE_MATERIAL_URL = COMPOSITE_MATERIALS_URL + "/{materialId}";

    public static final String EXTENDED_PARAM_NAME = "extended";
    public static final String FILES_URL = "/files";
    public static final String OPTIMIZATIONS_URL = "/optimizations";
    public static final String OPTIMIZATION_DEPENDENCIES_URL = OPTIMIZATIONS_URL + "/dependencies";

    public static final String TOSCA_SUGGEST_URL = "/optimizationType/{optimizationTypeId}/Tosca";
    public static final String TOSCA_SETTINGS_URL = OPTIMIZATIONS_URL + "/{optimizationId}/Tosca";
    public static final String TOSCA_BASE_SETTINGS_URL = TOSCA_SETTINGS_URL + "/basic";
    public static final String TOSCA_TARGET_FUNCS_URL = TOSCA_SETTINGS_URL + "/targetFunctions";
    public static final String TOSCA_SETS_URL = TOSCA_SETTINGS_URL + "/sets";
    public static final String TOSCA_CONSTRAINT_URL = TOSCA_SETTINGS_URL + "/constraints";
    public static final String TOSCA_TECH_CONSTRAINT_URL = TOSCA_SETTINGS_URL + "/technologicalConstraints";

    public static final String MF_SUGGEST_URL = OPTIMIZATIONS_URL + "/ModeFrontier";
    public static final String MF_SETTINGS_URL = OPTIMIZATIONS_URL + "/{optimizationId}/ModeFrontier";
    public static final String MF_BASE_SETTINGS_URL = MF_SETTINGS_URL + "/basic";
    public static final String MF_TARGET_FUNCS_URL = MF_SETTINGS_URL + "/targetFunctions";
    public static final String MF_CONSTRAIN_URL = MF_SETTINGS_URL + "/constraints";
    public static final String MF_SCRIPT_URL = MF_SETTINGS_URL + "/script";
    public static final String MF_VARYING_PARAMS_URL = MF_SETTINGS_URL + "/cao-borders";
    public static final String MF_CAD_VARYING_PARAMS_URL = MF_SETTINGS_URL + "/cad-borders";
    public static final String MF_SLICE_CHART_URL = MF_SETTINGS_URL + "/slice-chart";

    public static final String OPTISTRUCT_SUGGEST_URL = OPTIMIZATIONS_URL + "/Optistruct";
    public static final String OPTISTRUCT_SETTINGS_URL = OPTIMIZATIONS_URL + "/{optimizationId}/Optistruct";
    public static final String OPTISTRUCT_BASE_SETTINGS_URL = OPTISTRUCT_SETTINGS_URL + "/basic";
    public static final String OPTISTRUCT_ADDITIONAL_PARAMETERS_URL = OPTISTRUCT_SETTINGS_URL + "/additionalParameters";
    public static final String OPTISTRUCT_POSTPROCESSING_PARAMETERS_URL = OPTISTRUCT_SETTINGS_URL + "/postprocessingParameters";
    public static final String OPTISTRUCT_TF_URL = OPTISTRUCT_SETTINGS_URL + "/targetFunctions";
    public static final String OPTISTRUCT_CONSTRAINT_URL = OPTISTRUCT_SETTINGS_URL + "/constraints";
    public static final String OPTISTRUCT_TECH_CONSTRAINT_URL = OPTISTRUCT_SETTINGS_URL + "/technologicalConstraints";
    public static final String OPTISTRUCT_LOAD_STEP_URL = OPTISTRUCT_SETTINGS_URL + "/loadSteps";
    public static final String OPTISTRUCT_SETS_URL = OPTISTRUCT_SETTINGS_URL + "/sets";
    public static final String OPTISTRUCT_LNSETS_URL = OPTISTRUCT_SETTINGS_URL + "/lnsets";
    public static final String OPTISTRUCT_CONFIG_URL = OPTISTRUCT_SETTINGS_URL + "/configFile";


    public static final String OPTIMUS_SUGGEST_URL = OPTIMIZATIONS_URL + "/Optimus";
    public static final String OPTIMUS_SETTINGS_URL = OPTIMIZATIONS_URL + "/{optimizationId}/Optimus";
    public static final String OPTIMUS_BASE_SETTINGS_URL = OPTIMUS_SETTINGS_URL + "/basic";
    public static final String OPTIMUS_TARGET_FUNCS_URL = OPTIMUS_SETTINGS_URL + "/targetFunctions";
    public static final String OPTIMUS_CONSTRAIN_URL = OPTIMUS_SETTINGS_URL + "/constraints";
    public static final String OPTIMUS_SCRIPT_URL = OPTIMUS_SETTINGS_URL + "/script";
    public static final String OPTIMUS_VARYING_PARAMS_URL = OPTIMUS_SETTINGS_URL + "/cao-borders";
    public static final String OPTIMUS_CAD_VARYING_PARAMS_URL = OPTIMUS_SETTINGS_URL + "/cad-borders";
    public static final String OPTIMUS_SLICE_CHART_URL = OPTIMUS_SETTINGS_URL + "/slice-chart";

    public static final String RESULTS_URL = "/results";

    public static final String REPORTS_URL = "/reports";
    public static final String OPTIMIZATION_REPORTS_URL = OPTIMIZATIONS_URL + "/{optimizationId}" + REPORTS_URL;

    public static final String OPTIMIZATION_FILES_URL = OPTIMIZATIONS_URL + "/{optimizationId}/models";

    public static final String SOLVERS_URL = "/solvers";

    public static final String SUPPORT_URL = "/support";

    private URLs() {
    }


    public static boolean checkIsCompositeMaterial(HttpServletRequest request) {
        return request.getPathInfo() != null && request.getPathInfo().startsWith(COMPOSITE_MATERIALS_URL);
    }
}
