package ru.crp.lvms.utils;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.MessageSource;
import org.springframework.stereotype.Component;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.exceptions.EntityDeleteException;
import ru.crp.lvms.model.entities.UserEntity;

import javax.annotation.Nullable;
import java.util.List;
import java.util.function.BiFunction;

import static ru.crp.lvms.utils.MessageUtils.extractNames;

@Component
public class ValidationHelper {
    @Autowired
    private MessageSource msgSrc;

    public void checkDependencies(Integer entityId,
                                  String messageCode,
                                  BiFunction<Integer, UserEntity, List<? extends Named>> dependenciesResolver,
                                  @Nullable UserEntity currentUser) {
        List<? extends Named> dependencies = dependenciesResolver.apply(entityId, currentUser);
        if (!dependencies.isEmpty()) {
            String dependenciesNames = extractNames(dependencies);
            String errorMsg = msgSrc.getMessage(messageCode, new Object[]{dependenciesNames}, null);
            throw new EntityDeleteException(errorMsg, true);
        }
    }
}
