package ru.crp.lvms.validators;

import org.springframework.beans.factory.annotation.Value;

import javax.annotation.Nullable;
import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class FileExistsValidator implements ConstraintValidator<FileExists, String> {
    @Value("${storage.root}")
    private String baseDir;

    private Path pathToBaseDir;


    @Override
    public void initialize(FileExists constraintAnnotation) {
        pathToBaseDir = Paths.get(baseDir);
    }

    @Override
    public boolean isValid(@Nullable String value, ConstraintValidatorContext context) {
        return value == null || Files.exists(pathToBaseDir.resolve(value));
    }
}
