package ru.crp.lvms.validators;

import org.springframework.beans.factory.annotation.Autowired;
import ru.crp.lvms.optimizations.base.dao.OptimizationTypeSolverCombinationDao;
import ru.crp.lvms.optimizations.base.entities.OptimizationEntity;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;

public class SolversCombinationValidator implements ConstraintValidator<SolversCombinationAvailable, OptimizationEntity> {
    @Autowired
    private OptimizationTypeSolverCombinationDao optimizationTypeSolverCombinationDao;

    @Override
    public void initialize(SolversCombinationAvailable constraintAnnotation) {
        // intentional empty
    }

    @Override
    public boolean isValid(OptimizationEntity value, ConstraintValidatorContext context) {
        return optimizationTypeSolverCombinationDao.isCombinationAvailable(value.getOptimizationTypeId(),
                value.getSolverCaoId(), value.getSolverCaeId(), value.getSolverCadId());
    }
}
