package ru.crp.lvms.validators.task.optimization;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import ru.crp.lvms.model.entities.FileEntity;
import ru.crp.lvms.model.entities.tasks.TaskEntity;
import ru.crp.lvms.optimizations.base.entities.OptimizationEntity;
import ru.crp.lvms.optimizations.base.managers.OptimizationManager;
import ru.crp.lvms.validators.task.BaseTaskParamsValidator;

import java.util.List;

@Component
public class BaseOptimizationTaskParamsValidator extends BaseTaskParamsValidator<OptimizationEntity> {
    @Autowired
    protected OptimizationManager optimizationManager;

    @Override
    protected void doValidate(TaskEntity task, OptimizationEntity taskParent, Errors errors) {
        List<FileEntity> optimizationFiles = optimizationManager.getOptimizationFiles(taskParent, null);
        if (optimizationFiles.isEmpty()) {
            errors.reject("notEnoughOptimizationFiles");
        }
    }

    @Override
    protected OptimizationEntity getTaskParent(TaskEntity task) {
        return optimizationManager.findOne(task.getParentId(), null);
    }
}
