//package ru.crp.lvms.web;
//
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.core.MethodParameter;
//import org.springframework.security.access.AccessDeniedException;
//import org.springframework.stereotype.Component;
//import org.springframework.web.bind.ServletRequestUtils;
//import org.springframework.web.bind.support.WebDataBinderFactory;
//import org.springframework.web.context.request.NativeWebRequest;
//import org.springframework.web.method.support.HandlerMethodArgumentResolver;
//import org.springframework.web.method.support.ModelAndViewContainer;
//import ru.crp.cmlb.model.entities.base.Entity;
//import ru.crp.lvms.exceptions.BadRequestException;
//import ru.crp.lvms.managers.MaterialManager;
//import ru.crp.lvms.model.entities.MaterialEntity;
//import ru.crp.lvms.model.entities.FileEntity;
//import ru.crp.lvms.model.entities.UserEntity;
//import ru.crp.lvms.security.PortalUser;
//
//import javax.annotation.PostConstruct;
//import javax.servlet.http.HttpServletRequest;
//import java.util.HashMap;
//import java.util.Map;
//import java.util.function.BiFunction;
//
//@Component
//public class ExistedEntityArgumentResolver implements HandlerMethodArgumentResolver {
//
//    @Autowired
//    private MaterialManager materialManager;
//
//    private Map<Class<?>, BiFunction<Integer, UserEntity, Entity>> entityResolvers = new HashMap<>();
//
//    @PostConstruct
//    public void init() {
//        entityResolvers.put(MaterialEntity.class, materialManager::findOne);
//        entityResolvers.put(FileEntity.class, materialManager::getMaterialFile);
//    }
//    @Override
//    public boolean supportsParameter(MethodParameter parameter) {
//        return parameter.hasParameterAnnotation(ExistedEntity.class);
//    }
//
//    @Override
//    public Object resolveArgument(MethodParameter parameter,
//                                  ModelAndViewContainer mavContainer,
//                                  NativeWebRequest webRequest,
//                                  WebDataBinderFactory binderFactory) throws Exception {
//        ExistedEntity methodAnnotation = parameter.getParameterAnnotation(ExistedEntity.class);
//        Integer idParam = ServletRequestUtils.getIntParameter((HttpServletRequest) webRequest.getNativeRequest(),
//                methodAnnotation.idParamName());
//        if (idParam == null) {
//            throw new BadRequestException("'id' parameter is not present");
//        }
//        Class<?> parameterType = parameter.getParameterType();
//        BiFunction<Integer, UserEntity, Entity> resolver = entityResolvers.get(parameterType);
//        if (resolver == null) {
//            throw new IllegalArgumentException("No resolver for entity type " + parameterType);
//        }
//        PortalUser currentUser = PortalUser.getCurrentUser();
//        if (currentUser == null) {
//            throw new AccessDeniedException("Not authorized");
//        }
//        return resolver.apply(idParam, currentUser.getUser());
//    }
//}
