package ru.crp.lvms.web.controllers.effective.characteristics;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import ru.crp.cmlb.model.SuggestRequest;
import ru.crp.lvms.managers.misc.PreferencesManager;
import ru.crp.lvms.model.dao.DefectNameDao;
import ru.crp.lvms.model.entities.effective.characteristics.ECDefectEntity;
import ru.crp.lvms.model.entities.tree.DefectNameEntity;
import ru.crp.lvms.security.CurrentUser;
import ru.crp.lvms.security.PortalUser;
import ru.crp.lvms.web.controllers.misc.ColumnsController;

import javax.validation.Valid;
import java.util.List;

@RestController
@RequestMapping(value = "effectiveCharacteristics/defects", produces = MediaType.APPLICATION_JSON_VALUE)
public class ECDefectsController implements ColumnsController {
    @Autowired
    private PreferencesManager preferencesManager;

    @Autowired
    private DefectNameDao defectNameDao;

    @RequestMapping(value = "/suggest", method = RequestMethod.POST)
    public List<DefectNameEntity> suggest(@RequestBody @Valid SuggestRequest suggestRequest,
                                          @CurrentUser PortalUser currentUser) {
        return defectNameDao.suggest(suggestRequest, currentUser.getUser().getId());
    }

    @Override
    public Class getOutVoClass() {
        return ECDefectEntity.class;
    }

    @Override
    public PreferencesManager getPreferencesManager() {
        return preferencesManager;
    }
}
