package ru.crp.lvms.web.dto;

import ru.crp.lvms.model.entities.ParameterSample;
import ru.crp.lvms.model.entities.ParameterValues;
import ru.crp.lvms.model.entities.ParametersEntityTable;

import javax.annotation.Nullable;
import java.math.BigDecimal;

public class DefaultParameterValue {
    private int id;
    private String paramName;
    private BigDecimal paramValue;
    private BigDecimal defaultTemperature;

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getParamName() {
        return paramName;
    }

    public void setParamName(String paramName) {
        this.paramName = paramName;
    }

    public BigDecimal getParamValue() {
        return paramValue;
    }

    public void setParamValue(@Nullable BigDecimal paramValue) {
        this.paramValue = paramValue;
    }


    public BigDecimal getDefaultTemperature() {
        return defaultTemperature;
    }

    public void setDefaultTemperature(BigDecimal defaultTemperature) {
        this.defaultTemperature = defaultTemperature;
    }

    public DefaultParameterValue() {
    }


    public static BigDecimal extractValueForTemp(BigDecimal defaultTemp, ParameterValues parameterValues) {
        return parameterValues.getValuesList().stream()
                .filter(parameterSample ->
                        parameterSample.getTemperature().doubleValue() == defaultTemp.doubleValue())
                .findFirst()
                .map(ParameterSample::getParamValue)
                .orElse(null);
    }


    public static DefaultParameterValue extractFromParameterEntity(ParametersEntityTable parametersEntity,
                                                                   BigDecimal temp,
                                                                   @Nullable BigDecimal paramValue
                                                                   ) {
        DefaultParameterValue defaultParameterValue = new DefaultParameterValue();
        defaultParameterValue.setId(parametersEntity.getId());
        defaultParameterValue.setParamName(parametersEntity.getName());
        defaultParameterValue.setDefaultTemperature(temp);
        defaultParameterValue.setParamValue(paramValue);
        return defaultParameterValue;
    }
}
