package ru.crp.lvms.web.dto;

import org.hibernate.validator.constraints.NotEmpty;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.model.entities.MaterialEntity;
import ru.crp.lvms.model.entities.misc.ItemType;
import ru.crp.lvms.validators.ParentExists;
import ru.crp.lvms.validators.Unique;
import ru.crp.lvms.web.dto.misc.ValueObject;

import javax.validation.constraints.NotNull;

@Unique(entityClass = MaterialEntity.class, fieldName = "name", columnNane = "name", message = "Имя должно быть уникально")
public class MaterialIn extends ValueObject implements Entity {
    private int id;

    @NotEmpty(message = "Имя не может быть пустым")
    private String name;

    private String manufacture;
    private String source;

    @ParentExists(message = "Неверный путь", parentTypes = ItemType.Folder)
    @NotNull(message = "Папка должна быть задана")
    private Integer pid;
    private String description;
    private Integer typeId = 1; //default material type id
    private boolean lock;

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getManufacture() {
        return manufacture;
    }

    public void setManufacture(String manufacture) {
        this.manufacture = manufacture;
    }

    public String getSource() {
        return source;
    }

    public void setSource(String source) {
        this.source = source;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public boolean isLock() {
        return lock;
    }

    public void setLock(boolean lock) {
        this.lock = lock;
    }

    public Integer getPid() {
        return pid;
    }

    public void setPid(Integer pid) {
        this.pid = pid;
    }

    public Integer getTypeId() {
        return typeId;
    }

    public void setTypeId(Integer typeId) {
        this.typeId = typeId;
    }
}
