package ru.crp.lvms.web.dto.columns;

import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import ru.crp.lvms.model.entities.ColumnPrefsEntity;

import javax.validation.constraints.NotNull;

public class FieldMapping implements Comparable<FieldMapping> {
    @NotNull
    private String name;

    private String label;

    private GridColumnType cell;

    private boolean editable = false;

    private String suggest;

    private int order;

    private int width = -1;

    private int perpage = 25;

    @NotNull
    private Boolean renderable = true;

    public FieldMapping() {
    }

    public FieldMapping(ColumnPrefsEntity entity) {
        cell = entity.getCell();
        renderable = !entity.getIsExcluded();
        label = entity.getLabel();
        name = entity.getName();
        width = entity.getWidth();
        order = entity.getOrder();
    }

    @Override
    public boolean equals(Object o) {
        return EqualsBuilder.reflectionEquals(this, o);
    }

    @Override
    public int hashCode() {
        return HashCodeBuilder.reflectionHashCode(this);
    }

    @Override
    public int compareTo(FieldMapping o) {
        return this.order - o.order;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public GridColumnType getCell() {
        return cell;
    }

    public void setCell(GridColumnType cell) {
        this.cell = cell;
    }

    public boolean isEditable() {
        return editable;
    }

    public void setEditable(boolean editable) {
        this.editable = editable;
    }

    public String getSuggest() {
        return suggest;
    }

    public void setSuggest(String suggest) {
        this.suggest = suggest;
    }

    public int getOrder() {
        return order;
    }

    public void setOrder(int order) {
        this.order = order;
    }

    public int getWidth() {
        return width;
    }

    public void setWidth(int width) {
        this.width = width;
    }

    public int getPerpage() {
        return perpage;
    }

    public void setPerpage(int perpage) {
        this.perpage = perpage;
    }

    public Boolean getRenderable() {
        return renderable;
    }

    public void setRenderable(Boolean renderable) {
        this.renderable = renderable;
    }
}
