package ru.crp.lvms.web.dto.misc;

import javax.annotation.Nullable;

public class ResponseMessage {
    public enum Status {
        success, error, warning
    }

    private String message;
    private Status status;
    private Object value;

    private ResponseMessage(String message, Status status, Object value) {
        this.message = message;
        this.status = status;
        this.value = value;
    }

    public static ResponseMessage createError(String message) {
        return new ResponseMessage(message, Status.error, null);
    }

    public static ResponseMessage createWarning(String message) {
        return new ResponseMessage(message, Status.warning, null);
    }

    public static ResponseMessage createSuccess(String message) {
        return new ResponseMessage(message, Status.success, null);
    }


    public static ResponseMessage createError(String message, @Nullable Object value) {
        return new ResponseMessage(message, Status.error, value);
    }

    public static ResponseMessage createWarning(String message, @Nullable Object value) {
        return new ResponseMessage(message, Status.warning, value);
    }

    public static ResponseMessage createSuccess(String message, @Nullable Object value) {
        return new ResponseMessage(message, Status.success, value);
    }

    public String getMessage() {
        return message;
    }

    public Status getStatus() {
        return status;
    }

    public Object getValue() {
        return value;
    }
}
