package ru.crp.lvms.web.dto.pagination;

import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PageingResponse<T> extends PageImpl<T> {
    private static final long serialVersionUID = 1L;

    private Map<String, Object> filterValues = new HashMap<>();

    public PageingResponse(List<T> content) {
        super(content);
    }

    public PageingResponse(List<T> content, Pageable pageable, long total) {
        super(content, pageable, total);
    }

    public PageingResponse(List<T> content, Map<String, Object> filterValues, Pageable pageable, long total) {
        super(content, pageable, total);
        this.filterValues = filterValues;
    }

    public Map<String, Object> getFilterValues() {
        return filterValues;
    }

    public void setFilterValues(Map<String, Object> filterValues) {
        this.filterValues = filterValues;
    }

}
