package ru.crp.lvms.web.dto.user;

import org.hibernate.validator.constraints.Email;
import org.hibernate.validator.constraints.NotBlank;
import ru.crp.lvms.web.dto.misc.ValueObject;

import javax.annotation.Nullable;
import javax.validation.constraints.NotNull;
import java.util.Date;


public class UserIn extends ValueObject {

    @NotBlank(message = "Почта неможет быть пуста")
    @Email(message = "Неверный формат почты")
    private String email;
    @NotBlank(message = "Имя пользователя не может быть пусто")
    private String name;
    @NotNull(message = "Телефон не может быть пустым")
    private String phone = "";
    private Date birthDate;
    private boolean notified;

    private Integer roleId;

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public Date getBirthDate() {
        return birthDate != null ? new Date(birthDate.getTime()) :  null;
    }

    public void setBirthDate(@Nullable Date birthDate) {
        this.birthDate = birthDate != null ? new Date(birthDate.getTime()) : null;
    }

    public boolean isNotified() {
        return notified;
    }

    public void setNotified(boolean notified) {
        this.notified = notified;
    }

    public Integer getRoleId() {
        return roleId;
    }

    public void setRoleId(Integer roleId) {
        this.roleId = roleId;
    }

}
