package ru.crp.lvms.web.dto.user;

import com.fasterxml.jackson.annotation.JsonFormat;

import javax.annotation.Nonnull;

@JsonFormat(shape = JsonFormat.Shape.OBJECT)
public enum UserRole {
    Administrator("ROLE_ADMIN", "Администратор"),
    User("ROLE_USER", "Пользователь"),
    Guest("ROLE_GUEST", "Гость");

    private int id;
    private String uname;
    private String displayName;
    private String _name;
    private int priority;

    UserRole(String uname, String displayName) {
        this.uname = uname;
        this.displayName = displayName;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public int getPriority() {
        return priority;
    }

    public void setPriority(int priority) {
        this.priority = priority;
    }

    public String getName() {
        return _name;
    }

    public void setName(String name) {
        this._name = name;
    }

    public String getUname() {
        return uname;
    }

    public String getDisplayName() {
        return displayName;
    }

    @Nonnull
    public static UserRole valueOf(int id) {
        for (UserRole role : values()) {
            if (role.getId() == id) {
                return role;
            }
        }
        throw new IllegalArgumentException("Enum value for id " + id + " is not found in db");
    }
}
