DROP VIEW IF EXISTS parameters_materials_join;

ALTER TABLE parameters ADD COLUMN ordering INTEGER NOT NULL DEFAULT 0;

CREATE VIEW parameters_materials_join AS
  SELECT
    pa.id,
    pa.type,
    pa.name,
    pm.material_id                            AS material_id,
    pfm.file_id                               AS parameter_file_id,
    array_agg(pm.id ORDER BY pm.temp)         AS id_list,
    array_agg(pm.value ORDER BY pm.temp)      AS values_list,
    array_agg(pm.func_value ORDER BY pm.temp) AS func_values_list,
    array_agg(pm.sim_value ORDER BY pm.temp)  AS sim_values_list,
    array_agg(pm.temp ORDER BY pm.temp)       AS temp_list
  FROM parameters pa
    INNER JOIN parameters_materials pm ON pa.id = pm.parameter_id
    LEFT JOIN parameter_files_materials pfm ON pm.material_id = pfm.composite_material_id AND pa.id = pfm.parameter_id
  GROUP BY pa.id, pm.material_id, pfm.file_id;

UPDATE parameters SET ordering = id WHERE id <= 22;
UPDATE parameters SET ordering = id + 15 WHERE id > 22;

INSERT INTO parameters (name, type, material_relation, owner_id, ordering) VALUES
    (U&'\03C4<sub>пр12</sub>, МПа', 0, 1, 1, 23),
    (U&'\03C4<sub>пр13</sub>, МПа', 0, 1, 1, 24),
    (U&'\03C4<sub>пр23</sub>, МПа', 0, 1, 1, 25),
    (U&'\03B5<sub>пр1+</sub>', 0, 1, 1, 26),
    (U&'\03B5<sub>пр2+</sub>', 0, 1, 1, 27),
    (U&'\03B5<sub>пр3+</sub>', 0, 1, 1, 28),
    (U&'\03B5<sub>пр1-</sub>', 0, 1, 1, 29),
    (U&'\03B5<sub>пр2-</sub>', 0, 1, 1, 30),
    (U&'\03B5<sub>пр3-</sub>', 0, 1, 1, 31),
    (U&'\03B5<sub>пр12</sub>', 0, 1, 1, 32),
    (U&'\03B5<sub>пр13</sub>', 0, 1, 1, 33),
    (U&'\03B5<sub>пр23</sub>', 0, 1, 1, 34),
    (U&'C<sub>12</sub>', 0, 1, 1, 35),
    (U&'C<sub>13</sub>', 0, 1, 1, 36),
    (U&'C<sub>23</sub>', 0, 1, 1, 37);