ALTER TABLE optimizations ADD COLUMN image_file_id INTEGER REFERENCES files (id);

DROP VIEW optimizations_join;

CREATE VIEW optimizations_join AS
  SELECT
    o.*,
    u.name                                                                                     AS owner,
    ss.uname                                                                                   AS solving_status,
    ps.uname                                                                                   AS postprocessing_status,
    ot.name                                                                                    AS optimization_type,
    opf.path_names || '/' :: VARCHAR || o.name :: VARCHAR                                      AS path_names,
    opf.path || concat('{', '"name":"', o.name, '", "id":', o.id, ', "type":null}') :: VARCHAR AS path,
    o2.name                                                                                    AS reference,
    fi.name                                                                                    AS image_name
  FROM optimizations o
    JOIN users u ON u.id = o.owner_id
    JOIN solving_statuses ss ON ss.id = o.solving_status_id
    JOIN postprocessing_statuses ps ON ps.id = o.postprocessing_status_id
    JOIN optimization_types ot ON ot.id = o.optimization_type_id
    JOIN optimization_folders opf ON opf.id = o.pid
    LEFT JOIN optimizations o2 ON o2.id = o.reference_id
    LEFT JOIN files fi ON fi.id = o.image_file_id;