CREATE OR REPLACE RULE nodes_alive_CREATE AS ON INSERT TO nodes_alive DO INSTEAD (
  INSERT INTO nodes (name, num_cores, memory, url, description, alive, owner_id) VALUES
    (NEW.name, NEW.num_cores, NEW.memory, NEW.url, NEW.description, NEW.alive, NEW.owner_id)
  RETURNING nodes.*, NULL :: VARCHAR AS owner, NULL :: VARCHAR[] AS available_solvers);

CREATE OR REPLACE RULE nodes_alive_UPDATE AS ON UPDATE TO nodes_alive DO INSTEAD (
    UPDATE nodes
      SET name = NEW.name,
          num_cores = NEW.num_cores,
          memory = NEW.memory,
          url = NEW.url,
          description = NEW.description,
          owner_id = NEW.owner_id,
          alive = NEW.alive
    WHERE id = NEW.id);
