DROP VIEW optimizations_join;

ALTER TABLE optimization_base_settings ADD UNIQUE(optimization_id, type_id);

ALTER TABLE optimizations DROP COLUMN postprocessing_status_id;
ALTER TABLE optimizations DROP COLUMN solving_status_id;
ALTER TABLE optimizations ADD COLUMN status_id INTEGER NOT NULL DEFAULT 1 REFERENCES virtual_simulation_statuses;

CREATE VIEW optimizations_join AS
  SELECT
    o.*,
    os.display_name                                                                            AS solver_name,
    u.name                                                                                     AS owner,
    vss.display_name                                                                           AS status,
    ot.name                                                                                    AS optimization_type,
    opf.path_names || '/' :: VARCHAR || o.name :: VARCHAR                                      AS path_names,
    opf.path || concat('{', '"name":"', o.name, '", "id":', o.id, ', "type":null}') :: VARCHAR AS path,
    o2.name                                                                                    AS reference,
    fi.name                                                                                    AS image_name
  FROM optimizations o
    JOIN optimization_solvers os ON os.id = o.solver_id
    JOIN users u ON u.id = o.owner_id
    JOIN virtual_simulation_statuses vss ON vss.id = o.status_id
    JOIN optimization_types ot ON ot.id = o.optimization_type_id
    JOIN optimization_folders opf ON opf.id = o.pid
    LEFT JOIN optimizations o2 ON o2.id = o.reference_id
    LEFT JOIN files fi ON fi.id = o.image_file_id;

