CREATE TABLE parameters (
  id                SERIAL,
  name              VARCHAR UNIQUE                             NOT NULL,
  type              INTEGER                                    NOT NULL,
  --   0 - only for materials, 1 - only for composite materials, 2 - both cases
  material_relation INTEGER                                    NOT NULL,
  date_created      TIMESTAMP WITHOUT TIME ZONE DEFAULT now()  NOT NULL,
  date_modified     TIMESTAMP WITHOUT TIME ZONE DEFAULT now()  NOT NULL,
  owner_id          INTEGER DEFAULT 0,

  PRIMARY KEY (id),
  FOREIGN KEY (owner_id) REFERENCES users (id)
);


CREATE TRIGGER parameters_update
BEFORE UPDATE ON parameters
FOR EACH ROW
WHEN (OLD.* IS DISTINCT FROM NEW.*)
EXECUTE PROCEDURE update_last_modified();
