ALTER TABLE optistruct_optimization_base_setting_types ADD COLUMN min_value INTEGER NOT NULL DEFAULT 1;
-- id 2 belongs to Technological constraint
UPDATE optistruct_optimization_base_setting_types SET min_value = 0 WHERE id = 2;

DROP VIEW optistruct_optimization_base_settings_join;

CREATE VIEW optistruct_optimization_base_settings_join AS (
  SELECT obs.*,
    obst.max_value AS max_value,
    obst.min_value AS min_value,
    obst.display_name AS name

  FROM optistruct_optimization_base_settings obs
    JOIN optistruct_optimization_base_setting_types obst ON obs.type_id = obst.id
);

CREATE RULE optistruct_optimization_base_settings_join_CREATE AS ON INSERT TO optistruct_optimization_base_settings_join DO INSTEAD (
  INSERT INTO optistruct_optimization_base_settings (type_id, optimization_id, current_value)
  VALUES (NEW.type_id, NEW.optimization_id, NEW.current_value)
  RETURNING
    optistruct_optimization_base_settings.*,
    NULL :: INTEGER AS max_value,
    NULL :: INTEGER AS min_value,
    NULL :: VARCHAR(255) AS name
);

CREATE RULE optistruct_optimization_base_settings_join_UPDATE AS ON UPDATE TO optistruct_optimization_base_settings_join DO INSTEAD (
  UPDATE optistruct_optimization_base_settings
  SET current_value = NEW.current_value
  WHERE id = NEW.id);

CREATE RULE optistruct_optimization_base_settings_join_DELETE AS ON DELETE TO optistruct_optimization_base_settings_join DO INSTEAD (
  DELETE FROM optistruct_optimization_base_settings WHERE id = OLD.id
);
