DROP TRIGGER effective_characteristics_parameters_join_check_ec_average_thickness_allowed
ON effective_characteristics_parameters_join;

CREATE OR REPLACE FUNCTION check_ec_average_thickness_allowed()
  RETURNS TRIGGER AS $body$
BEGIN
  --  average_width is used only for effective_characteristics with technologies with 'ADDITIVE_3CM' type
  IF NOT EXISTS(
      SELECT *
      FROM effective_characteristics ec
        JOIN composite_materials cm
          ON ec.composite_material_id = cm.id
        JOIN technologies t
          ON cm.technology_id = t.id
      WHERE ec.id = NEW.effective_characteristic_id
            AND cm.id = ec.composite_material_id
            AND t.technology_type = 'ADDITIVE_3CM')
     AND NEW.param_id = 13
  THEN
    NEW.param_value := NULL;
  END IF;
  RETURN NEW;
END;
$body$ LANGUAGE plpgsql;

CREATE TRIGGER effective_characteristics_parameters_join_check_ec_average_thickness_allowed
BEFORE INSERT OR UPDATE ON effective_characteristics_parameters_join
FOR EACH ROW
EXECUTE PROCEDURE check_ec_average_thickness_allowed();
