(function () {

  "use strict";

  window.App.Behaviors.PluginsInit = Marionette.Behavior.extend({

    defaults: {
      ajaxFormConfig: {},
      select2Events:[],
      fileupload: {
        el: "",
        className: "" //appends to class of fileupload input group
      },
      select2: [],
      autosize: {} // {el: el,  }
    },

    onRender: function () {
      var that = this;
      // this.view.$("select").select2();


      if (this.options.select2.length > 0) {
        _.each(that.options.select2, function (config) {
          that.view.$(config.el).select2(config);
        }, this);
      }

      if (this.view.$(this.options.fileupload.el).length) {
        this.view.$(this.options.fileupload.el).fileinput({
          showUpload: false,
          uploadClass: "btn btn-info btn-submodel-upload",
          maxFileCount: 100,
          mainClass: "input-group-sm " + this.options.fileupload.className || "",
          browseLabel: "Выбрать ..."
        });
      }

      var submitForm = function(e) {
        e.preventDefault();

        $(this).parents(".image-upload-form").ajaxForm({
          url: that.view.model.url() + "/image", //Path to upload model files
          type: 'POST',
          success: function(res) {
            window.alertify.success("Image Uploaded");
          },
          error: function(res) {
            window.alertify.error("Upload failed ", res.message);
            console.error("Upload error: ", res)
          }
        }).submit();
      };

      if (this.view.$(this.options.ajaxFormConfig.el).length) {
        this.view.$(this.options.ajaxFormConfig.el).on("change", submitForm);
      }

      if(this.options.select2Events.length > 0) {
        _.each(that.options.select2Events, function(event) {
          that.view.$(event.el).on(event.event, function(e){
            event.eventCallback.call(that, e)
          })
        })
      }

    }
  });
}());