/**
 * Created by lexeek on 14.09.14.
 */

(function () {
  App.Controllers.ProjectNavigationController = Marionette.Controller.extend({

    project: function () {
      window.App.navigate("#project/home", {trigger: true});
    },

    home: function () {
      window.App.ProjectModule.showProjectPage({page: "ProjectHomePage"});
    },

    ProjectTaskPage: function (id) {
      window.App.ProjectModule.showProjectPage({page: "ProjectTaskPage", id: id});
    },

    ProjectMaterialsListPage: function () {
      window.App.ProjectModule.showProjectPage({page: "ProjectMaterialsListPage"});
    },

    ProjectMaterialCreatePage: function (params) {
      var treeNode = URI.parseQuery(params);
      window.App.ProjectModule.showProjectPage({page: "ProjectMaterialCreatePage", treeNode: treeNode});
    },

    ProjectMaterialParametersPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectMaterialParametersPage", id: id, mode: mode});
    },

    ProjectMaterialFilesPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectMaterialFilesPage", id: id, mode: mode});
    },

    ProjectCompositeMaterialsListPage: function () {
      window.App.ProjectModule.showProjectPage({page: "ProjectCompositeMaterialsListPage"});
    },

    ProjectCompositeMaterialCreatePage: function (params) {
      var treeNode = URI.parseQuery(params);
      window.App.ProjectModule.showProjectPage({page: "ProjectCompositeMaterialCreatePage", treeNode: treeNode});
    },

    ProjectCompositeMaterialParametersPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectCompositeMaterialParametersPage", id: id, mode: mode});
    },

    ProjectCompositeMaterialEffectiveCharacteristicsPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({
        page: "ProjectCompositeMaterialEffectiveCharacteristicsPage",
        id: id,
        mode: mode
      });
    },

    ProjectCompositeMaterialEffectiveCharacteristicCreatePage: function (id) {
      window.App.ProjectModule.showProjectPage({
        page: "ProjectCompositeMaterialEffectiveCharacteristicCreatePage",
        id: id
      });
    },

    ProjectCompositeMaterialSimulationsPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectCompositeMaterialSimulationsPage", id: id, mode: mode});
    },

    ProjectCompositeMaterialSimulationCreatePage: function (id) {
      window.App.ProjectModule.showProjectPage({page: "ProjectCompositeMaterialSimulationCreatePage", id: id});
    },

    ProjectCompositeMaterialFilesPage: function (id, fileType, mode) {
      window.App.ProjectModule.showProjectPage({
        page: "ProjectCompositeMaterialFilesPage",
        id: id,
        fileType: fileType,
        mode: mode
      });
    },

    ProjectEffectiveCharacteristicPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectEffectiveCharacteristicPage", id: id, mode: mode});
    },

    ProjectEffectiveCharacteristicResultsPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectEffectiveCharacteristicResultsPage", id: id, mode: mode});
    },

    ProjectSimulationParametersPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectSimulationParametersPage", id: id, mode: mode});
    },

    ProjectSimulationResultsPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectSimulationResultsPage", id: id, mode: mode});
    },

    ProjectUsersPage: function () {
      window.App.ProjectModule.showProjectPage({page: "ProjectUsersPage"});
    },

    ProjectCreateUserPage: function () {
      window.App.ProjectModule.showProjectPage({page: "ProjectCreateUserPage"});
    },

    ProjectTechnologiesListPage: function () {
      window.App.ProjectModule.showProjectPage({page: "ProjectTechnologiesListPage"});
    },

    ProjectTechnologyCreatePage: function () {
      window.App.ProjectModule.showProjectPage({page: "ProjectTechnologyCreatePage"});
    },

    ProjectTechnologyParameterCreatePage: function (technologyId, parameterType) {
      window.App.ProjectModule.showProjectPage({
        page: "ProjectTechnologyParameterCreatePage",
        technologyId: technologyId,
        parameterType: parameterType
      });
    },

    ProjectTechnologyParametersPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectTechnologyParametersPage", id: id, mode: mode})
    },

    ProjectTechnologySimulationsPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectTechnologySimulationsPage", id: id, mode: mode})
    },

    ProjectTechnologySimulationCreatePage: function (id) {
        window.App.ProjectModule.showProjectPage({
            page: "ProjectTechnologySimulationCreatePage",
            id: id
        });
    },

    ProjectTechnologySimulationsPage: function (id, mode) {
        window.App.ProjectModule.showProjectPage({page: "ProjectTechnologySimulationsPage", id: id, mode: mode})
    },

    ProjectTechnologySimulationParametersPage: function (id, mode) {
        window.App.ProjectModule.showProjectPage({page: "ProjectTechnologySimulationParametersPage", id: id, mode: mode});
    },

    ProjectTechnologySimulationCopyPage: function (params) {
        params = params ? window.App.Helpers.getParmsFromURLHash('?'+params) : '';
        window.App.ProjectModule.showProjectPage({page: "ProjectTechnologySimulationCopyPage", params: params});
    },

    ProjectConstructionElementsListPage: function () {
      window.App.ProjectModule.showProjectPage({page: "ProjectConstructionElementsListPage"});
    },

    ProjectConstructionElementCreatePage: function (params, getParam) {
      var treeNode = URI.parseQuery(params);
      window.App.ProjectModule.showProjectPage({page: "ProjectConstructionElementsCreatePage", treeNode: treeNode});
    },

    ProjectConstructionElementParametersPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectConstructionElementsParametersPage", id: id, mode: mode});
    },

    ProjectConstructionElementFilesPage: function (id, fileType, mode) {
      window.App.ProjectModule.showProjectPage({
        page: "ProjectConstructionElementsFilesPage",
        id: id,
        fileType: fileType,
        mode: mode
      });
    },

    ProjectCreateFilePage: function (objectType, objectId, fileType) {
      window.App.ProjectModule.showProjectPage({
        page: "ProjectCreateFilePage",
        objectType: objectType,
        objectId: objectId,
        fileType: fileType
      });
    },

    ProjectFileParametersPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectFileParametersPage", id: id, mode: mode});
    },

    ProjectOptimizationsListPage: function (params) {
      params = params ? window.App.Helpers.getParmsFromURLHash('?'+params) : '';
      window.App.ProjectModule.showProjectPage({page: "ProjectOptimizationsListPage", params: params});
    },

    ProjectOptimizationCreatePage: function (params) {
      params = params ? window.App.Helpers.getParmsFromURLHash('?'+params) : '';
      window.App.ProjectModule.showProjectPage({page: "ProjectOptimizationCreatePage", params: params});
    },

    ProjectOptimizationCopyPage: function (params) {
        params = params ? window.App.Helpers.getParmsFromURLHash('?'+params) : '';
        window.App.ProjectModule.showProjectPage({page: "ProjectOptimizationCopyPage", params: params});
    },

    ProjectOptimizationFolderCreatePage: function (itemType, parentType, params) {
      window.App.ProjectModule.showProjectPage({
        page: "ProjectOptimizationFolderCreatePage",
        params: _.extend(URI.parseQuery(params), {parentType: parentType, itemType: itemType})
      });
    },

    ProjectOptimizationParametersPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectOptimizationParametersPage", id: id, mode: mode});
    },

    ProjectOptimizationSettingsPage: function (id, mode, tab) {
      window.App.ProjectModule.showProjectPage({page: "ProjectOptimizationSettingsPage", id: id, mode: mode, tab: tab});
    },

    ProjectOptimizationLevelsPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectOptimizationLevelsPage", id: id, mode: mode});
    },

    ProjectOptimizationReferencesPage: function (id, mode) {
      window.App.ProjectModule.showProjectPage({page: "ProjectOptimizationReferencesPage", id: id, mode: mode});
    },

    ProjectQueuePage: function () {
      window.App.ProjectModule.showProjectPage({page: "ProjectQueuePage"});
    }

  });
}());
