/**
 * Created by tikhonov on 13/12/14.
 */

(function () {

  window.App.Helpers.Select2Config = function (options) {
    var that = this;
    that.options = options || {};

    if (!options || !options.url && !options.local) {
      console.error("Select2Config, invalid config", options);
      return;
    }

    function getData (params) {
      if (!params.term) {
        params.term = options.term || "";
      }

      var jsonData = _.extend(that.options.data || {},{
        pageLimit: options.pageLimit || 10,
        queries: _.union([
          _.extend({
            column: options.fieldName || "name", //INFO - field to search, default 'name'
            value: "%" + params.term + "%"
          },that.options.qparams || {})
        ], that.options.queries || [])
      });

      return JSON.stringify(jsonData);
    }

    that.config = {
      el: options.el || "",
      allowClear: !!options.allowClear,
      placeholder: options.placeholder || "",
      minimumInputLength: options.minimumInputLength || 0,
      language: "ru",
      ajax: {
        type: options.type || 'POST',
        url: options.url,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        data: getData.bind(this),
        processResults: function (data, page) {
          if (data.length === 0) return {results: []};
          _.map(data, function (obj) {
            obj.text = obj.name;
            return obj;
          });

          that.config.results = data;
          options.dataloaded && typeof options.dataloaded === 'function'?  options.dataloaded(data) : null;
          return {results: data};
        }
      },
      templateResult: options.templateResult
    };

    return this.config;
  };
})();