  /**
 * Created by lexeek on 15.09.14.
 */


(function () {
  "use strict";

  window.App.Routers.ProjectRouter = Backbone.Marionette.AppRouter.extend({

    appRoutes: {
      "project(/)": "project",
      "project/home(/)": "home",
      "project/tasks/:id": "ProjectTaskPage",
      "project/materials(/)": "ProjectMaterialsListPage",
      "project/materials/create(/)": "ProjectMaterialCreatePage",
      "project/materials/:id/parameters/:mode(/)": "ProjectMaterialParametersPage",
      "project/materials/:id/files/:mode(/)": "ProjectMaterialFilesPage",
      "project/compositeMaterials(/)": "ProjectCompositeMaterialsListPage",
      "project/compositeMaterials/create(/)": "ProjectCompositeMaterialCreatePage",
      "project/compositeMaterials/:id/parameters/:mode(/)": "ProjectCompositeMaterialParametersPage",
      "project/compositeMaterials/:id/effectiveCharacteristics/create(/)": "ProjectCompositeMaterialEffectiveCharacteristicCreatePage",
      "project/compositeMaterials/:id/effectiveCharacteristics/:mode(/)": "ProjectCompositeMaterialEffectiveCharacteristicsPage",
      "project/compositeMaterials/:id/simulations/create(/)": "ProjectCompositeMaterialSimulationCreatePage",
      "project/compositeMaterials/:id/simulations/:mode(/)": "ProjectCompositeMaterialSimulationsPage",
      "project/compositeMaterials/:id/:fileType/:mode(/)": "ProjectCompositeMaterialFilesPage",
      "project/effectiveCharacteristics/:id/parameters/:mode(/)": "ProjectEffectiveCharacteristicPage",
      "project/effectiveCharacteristics/:id/results/:mode(/)": "ProjectEffectiveCharacteristicResultsPage",
      "project/simulations/:id/parameters/:mode(/)": "ProjectSimulationParametersPage",
      "project/simulations/:id/results/:mode(/)": "ProjectSimulationResultsPage",
      "project/users(/)": "ProjectUsersPage",
      "project/users/create(/)": "ProjectCreateUserPage",
      "project/technologies": "ProjectTechnologiesListPage",
      "project/technologies/create(/)": "ProjectTechnologyCreatePage",
      "project/technologies/:id/technologySimulations/create(/)": "ProjectTechnologySimulationCreatePage",
      "project/technologies/:id/:parameterType/create(/)": "ProjectTechnologyParameterCreatePage",
      "project/technologies/:id/parameters/:mode(/)": "ProjectTechnologyParametersPage",
      "project/technologies/:id/simulations/:mode(/)": "ProjectTechnologyParametersPage",
      "project/technologies/:id/technologySimulations/:mode(/)": "ProjectTechnologySimulationsPage",
      "project/technologies/:id/:fileType/:mode(/)": "ProjectTechnologySimulationsPage",
      "project/technologySimulations/:id/parameters/:mode(/)": "ProjectTechnologySimulationParametersPage",
      "project/technologySimulations/:id/copy(/)": "ProjectTechnologySimulationCopyPage",
      "project/constructionElements": "ProjectConstructionElementsListPage",
      "project/constructionElements/create(/)": "ProjectConstructionElementCreatePage",
      "project/constructionElements/:id/parameters/:mode(/)": "ProjectConstructionElementParametersPage",
      "project/constructionElements/:id/:fileType/:mode(/)": "ProjectConstructionElementFilesPage",
      "project/files/:objectType/:objectId/:fileType/create(/)": "ProjectCreateFilePage",
      "project/file/:id/:mode(/)": "ProjectFileParametersPage",
      "project/optimizations(/)": "ProjectOptimizationsListPage",
      "project/optimizations/create(/)": "ProjectOptimizationCreatePage",
      "project/optimizations/:id/copy(/)": "ProjectOptimizationCopyPage",
      "project/optimizations/:id/parameters/:mode(/)": "ProjectOptimizationParametersPage",
      "project/optimizations/:id/settings/:mode/:tab(/)": "ProjectOptimizationSettingsPage",
      "project/optimizations/:id/levels/:mode(/)": "ProjectOptimizationLevelsPage",
      "project/optimizations/:id/references/:mode(/)": "ProjectOptimizationReferencesPage",
      "project/optimizations/:itemType/:parentType/create": "ProjectOptimizationFolderCreatePage",
      "project/queue": "ProjectQueuePage"
    }

  });

})();