/**
 *
 * Admin Navigation Menu View
 *
 */


(function () {
  "use strict";

  window.App.Views.AdminNavigationView = Backbone.Marionette.ItemView.extend({
    template: "./views/templates/admin/admin_navigation.html.ejs",

    className: 'nav nav-tabs nav-justified',

    events: {
      "click @ui.navigationRoute" : "onClickNavigationRoute"
    },

    ui: {
      navigationRoute: ".navigate-route"
    },

    initialize: function () {},

    onClickNavigationRoute: function(e) {
      e.preventDefault();

      window.App.navigate($(e.target).data("route"), {trigger: true});
    },

    setActiveMenuItem: function (item) {
      if (this.$("#admin-" + item).length!==0 ) {
        this.$('#admin-' + item).tab('show').end().parent('.dropdown').tab('show');
      } else {
        this.$(".nav-tabs li").each(function () {
          $(this).removeClass("active");
        })
      }
    }
  });

})();