(function () {

  "use strict";

  window.App.Views._BasePage = Backbone.Marionette.LayoutView.extend({
    template: "./views/templates/project/common/base_page.html.ejs",
    regions: {
      controlsRegion: ".js-controls-region",
      mainRegion:     ".js-main-region",
      tableRegion:    ".js-table-region"
    },

    // In case you need to fetch data or implement any other logic before showing view use separate method in child view (inheritor)
    views: {
      controls: window.App.Views._BaseControls,
      main: window.App.Views._BaseMain
    },

    tableViewsSet: {},

    initialize: function (options) {
      this.options = options || {};
      this.isView = this.options.params ? this.options.params.mode == "view" : false;
      this.listenTo(this, "show:table", _.bind(this.showTable, this));
    },

    onRender: function () {
      this.showViews();
    },

    showTable: function () {
      console.log("base show table");
    },

    showViews: function () {
      var that = this;
      _.each(this.views, function (v, k) {
        if (!_.isUndefined(v)) that.getRegion(k + "Region").show(new v({
          model: that.model,
          status: that.options.status,
          isView: that.isView,
          layout: that
        }));
      });
    }

  });
}());
