(function () {

  "use strict";

  window.App.Views.BasePageTable = window.App.Views.CollapsableBlock.extend({
    template: "./views/templates/project/base_page_table.html.ejs",
    className: "",

    regions: {
      "bodyTableRegion": ".js-body-table-region"
    },

    initialize: function (options) {
      this.options = options || {};
      this.type = this.options.type.capitalize().replace("-", " ");
    },

    onRender: function () {
      this.initTable();
    },

    initTable: function () {
      var that = this;
      var type = this.type == "Simulation files" ? "Files" : this.type;
      if (type == "Animations" || type == "Pictures" || type == "Curves" || type == "Values" || type == "A4dbs" || type == "Presentations") {
        type = "Results";
      }
      var tableView = new window.App.Views["Simulation" + type + "Table"]({
        model: this.model,
        isView: this.options.isView,
        type: this.type,
        layout: this.options.layout
      });
      this.getRegion("bodyTableRegion").on("show", function () {
        if (tableView.grid) {
          that.listenTo(tableView.grid.gridCollection, "sync", function () {
            that.options.layout.trigger("update:table");
          });
        }
      });
      this.getRegion("bodyTableRegion").show(tableView);
    },

    templateHelpers: function () {
      return {
        isView: this.options.isView,
        title: this.type
      }
    }
  });
}());
