(function() {
  "use strict";
  window.App.Views.CompositeMaterialParametersPage = window.App.Views.CompositeMaterialBasePage.extend({
    template: "./views/templates/project/composite_material/composite_material_base_page.html.ejs",
    initialize: function () {
      window.App.Views.MaterialParametersPage.__super__.initialize.apply(this, arguments);
      this.page = "parameters";
    },

    onRender: function () {
      this.initAndShowMainView(this.getRegion("mainRegion"));
      this.initAndShowPlotView(this.getRegion("plotRegion"));
      this.initAndShowLayersView(this.getRegion("layersRegion"));
      window.App.Views.MaterialBasePage.prototype.onRender.call(this);
    },

    initAndShowMainView: function (region) {
      this.mainView = new window.App.Views.CompositeMaterialMainView({
        layoutView: this,
        mode: this.mode,
        model: this.model
      });
      region.show(this.mainView);
    },

    initAndShowLayersView: function (region) {
      var that = this;
      this.layers = new window.App.Collections.Layers({ compositeMaterialId: this.model.id });
      this.layers.fetch().done(function () {
        that.layersView = new window.App.Views.CompositeMaterialLayersView({
          layoutView: that,
          mode: that.mode,
          model: that.model,
          collection: that.layers
        });
        region.show(that.layersView);
      })
    },

    initAndShowPlotView: function (region) {
      var that = this;
      this.plotParameters = new window.App.Collections.PlotParameters({
        materialId: this.model.get("id"),
        materialType: "compositeMaterials"
      });
      this.plotParameters.fetch({
        success: function () {
          that.plotView = new window.App.Views.CompositeMaterialPlotView({
            layoutView: that,
            mode: that.mode,
            collection: that.plotParameters,
            materialId: that.model.id
          });
          region.show(that.plotView);
        }
      });
    }
  });

})();