(function () {
  "use strict";

  window.App.Views.CreateEffectiveCharacteristicView = Marionette.LayoutView.extend({
    template: "./views/templates/project/effective_characteristics/create_effective_characteristics.html.ejs",
    ui: {
      "name": ".js-name"
    },

    initialize: function (options) {
      this.options = options || {};
      this.model = new window.App.Models.EffectiveCharacteristic({}, { compositeMaterialId: this.options.compositeMaterialId });
      this.listenTo(this, "ok", this.onSubmit);
      this.listenTo(this, "cancel", this.onCancel);
    },

    passModal: function (md) {
      this.md = md;
    },

    onCancel: function() {
      window.App.navigate("#project/compositeMaterials/" + this.options.compositeMaterialId + "/effectiveCharacteristics/view", { trigger: true });
    },

    onSubmit: function(md) {
      md.preventClose();
      var name = this.ui.name.val();

      if (_.isEmpty(name))
        this.ui.name.closest(".form-group").addClass("has-error");
      else {
        this.model.save({
          name: name,
          compositeMaterialId: this.options.compositeMaterialId
        }, {
          success: function(model, resp) {
            window.App.vent.trigger('updateTreeNodes', {id: model.get("pid")}, 'compositeMaterials', window.App.Data.EntityTypes[3].type, "add");
            window.App.navigate("#project/effectiveCharacteristics/" + model.get("id") + "/parameters/edit", { trigger: true });
            md.close();
          }
        });
      }
    }

  });

}());