(function () {
  "use strict";

  window.App.Views.CreateFileView = Marionette.LayoutView.extend({
    template: null,
    className: "create-file",

    behaviors: {
      PluginsInit: {
        fileupload: {
          el: "#js-file-upload"
        }
      }
    },

    ui: {
      fileForm:     ".js-file-form",
      fileInp:      "#js-file-upload"
    },

    initialize: function (options) {
      this.options = options || {};
      this.template = this.options.fileType == "loadConditions" ? "./views/templates/project/files/create_load_case_file.html.ejs" : "./views/templates/project/files/create_file.html.ejs";
      this.listenTo(this, "ok", this.onSubmit);
      this.listenTo(this, "cancel", this.onCancel);
    },

    onCancel: function(md) {
      if (this.options.straightClose) {
        md.close()
      } else {
        window.history.back();
      }
    },

    passModal: function (md) {
      this.md = md;
    },

    onSubmit: function(md) {
      md.preventClose();
      if (!_.isEmpty(this.ui.fileInp.val()))
        this.uploadFile(md);
      else
        window.alertify.error("Необходимо загрузить файл.");
    },

    uploadFile: function (md) {
      var url = this.options.url || "rest/" + this.options.objectType + "/" + this.options.objectId + "/" + this.options.fileType;
      this.ui.fileForm.ajaxForm({
        url: url,
        type: "POST",
        success: (model) => {
          window.App.vent.trigger('updateTreeNodes', {id: model.pid}, window.App.Data.Trees[0].type, model.fileType, "add");
          if (!this.options.straightClose) window.history.back();
          md.close();
        }
      }).submit();
    }

  });

}());