(function () {
  "use strict";

  window.App.Views.ParametersDefaultValueView = Marionette.ItemView.extend({
    template: "./views/templates/project/material/material_parameter_default_value.html.ejs",
    className: function () {
      return this.options.isSelected ? "ui-selected ui-default-value" : "ui-default-value";
    },
    tagName: "tr",
    ui: {
      name: ".js-name",
      value: ".js-val"
    },
    events: {
      "click @ui.name": "onNameClick",
      "change @ui.value": "onValueChange"
    },
    initialize: function (options) {
      this.options = options || {};
      this.listenTo(this.model, "change", this.render);
    },

    onValueChange: function () {
      var value = !_.isEmpty(this.ui.value.val()) ? parseFloat(this.ui.value.val()) : null;
      this.options.currentParameter.trigger("update:default:value", { temperature: this.model.get("defaultTemperature"), paramValue: value })
    },

    onNameClick: function () {
      this.options.currentParameter.collection.trigger("change:current:parameter", this.model.id);
    },

    templateHelpers: function () {
      return {
        isSelected: this.options.isSelected
      }
    }

  });

})();