(function () {
  "use strict";

  window.App.Views.ParametersDefaultValuesView = Marionette.CompositeView.extend({
    template: "./views/templates/project/material/material_parameter_default_values.html.ejs",
    className: "ui-defaults-values-container",
    childViewContainer: ".js-defaults-values-container",
    childViewOptions: function (model) {
      return { isSelected: model == this.options.currentParameter, currentParameter:  this.options.currentParameter};
    },

    initialize: function (options) {
      this.options = options || {};
      this.listenTo(this.options.currentParameter, "update:defaults", this.changeDefault);
    },

    changeDefault: function (options) {
      var model = this.collection.findWhere({ id: this.options.currentParameter.id });
      if (model)
        model.set({ paramValue: options.value });
    },

    templateHelpers: function () {
      return {
        paramName: this.options.currentParameter.get("paramName")
      }
    },

    childView: window.App.Views.ParametersDefaultValueView

  });

})();