(function () {
  "use strict";

  window.App.Views.BasePathModal = Backbone.Marionette.LayoutView.extend({
    template: "./views/templates/project/modals/entity_tree_parameters.html.ejs",
    regions: {
      contentRegion: "#parameters-ztree-region",
      backgridRegion: "#parameters-backgrid-region"
    },

    initialize: function (options) {
      _.bindAll(this, "showFolders");

      this.options = options || {};
      this.options.expandTree = true;

      this.SidebarTreeController = new App.Controllers.TreeController();
      this.listenTo(this, "ok", this.okClicked);
    },

    onRender: function () {
      this.zSidebarTree = this.SidebarTreeController.showTree(_.extend(this.options, {
        region: this.getRegion("contentRegion")
      }));

      this.listenTo(this.zSidebarTree, "ztree:onclick", this.showFolders);
    },

    showFolders: function (event, treeId, treeNode) {

      var treeObj = $.fn.zTree.getZTreeObj(treeId);

      if (treeNode.parent) {
        treeObj.expandNode(treeNode);
      }

      this.treeNode = treeNode;
    }
  });

})();