(function () {
  "use strict";

  window.App.Views.AddModelToOptimization = window.App.Views.AddDependencyToOptimization.extend({
    template: "./views/templates/project/optimization/add_model_to_optimization.html.ejs",
    ui: _.extend({
      "select": ".js-select-dependency",
      "new": ".js-new"
    }, window.App.Views.AddDependencyToOptimization.prototype.ui),


    events: _.extend({
      "click @ui.new": "onNewClick"
    }, window.App.Views.AddDependencyToOptimization.prototype.events),

    behaviors: function () {
      return {
        PluginsInit: {
          select2Events: [],
          select2: [
            window.App.Helpers.Select2Config({
              el: ".js-select-dependency",
              placeholder: "Выберите объект",
              url: "rest/optimizations/" + this.options.optimizationId + "/" + this.options.type + "/available/suggest",
              isNumber: false,
              allowClear: true,
              minimumInputLength: 0
            })
          ]
        }
      }
    },

    onNewClick: function () {
      var target = "_self";
      var route = "#project/files/optimizations/" + this.options.optimizationId + "/" + this.options.type + "/create";
      this.md.close();
      window.open(route, target);
    },

    onSubmit: function (md) {
      var that = this;
      md.preventClose();
      var id = this.ui.select.val();
      $.ajax({
        type: "POST",
        url: "rest/optimizations/" + this.options.optimizationId + "/" + this.options.type + "?entityId=" + id,
        success: function () {
          window.App.commands.execute("optimization:dependency:added", "models");
          window.alertify.success("Успешно добавлено");
          that.options.collection.fetch();
          md.close();
        }
      })
    },

    templateHelpers: function () {
      var that = this;
      return {
        displayNameForButton: function () {
          var displayName = "";
          switch (that.options.type) {
            case "CAEFiles":
              displayName = "CAE-Файл";
              break;
            case "CADFiles":
              displayName = "CAD-Файл";
              break;
          }
          return displayName;
        }
      }
    }

  });

})();