(function () {
  "use strict";

  window.App.Views.CopyOptimizationView = Marionette.LayoutView.extend({
    template: "./views/templates/project/optimization/copy_optimization.html.ejs",
    className: "copy-optimization row",

    regions: {
      mainRegion: ".js-main-region"
    },

    ui: {
      name: ".js-name",
      isChild: ".js-isChild",
      nameForm: ".js-name-form"
    },

    initialize: function (options) {
      this.options = options || {};
      this.listenTo(this, "ok", this.onSubmit);
      this.listenTo(this, "cancel", this.onCancel);
    },

    passModal: function (md) {
      this.md = md;
    },

    onCancel: function () {
      var fillParams = function (params) {
        var p = "";
        if (params.path && params.optimizationTypeId ) {
          p += "?path=" + encodeURIComponent(params.path) + '&optimizationTypeId=' + params.optimizationTypeId
        }
        p += params.id ? "&id=" + params.id : "";
        return p
      };

      window.App.navigate("#project/optimizations" + fillParams(this.options.params), { trigger: true });
    },

    onSubmit: function (md) {
      md.preventClose();
      var name = this.ui.name.val();
      this.$(".form-group").removeClass('has-error');
      if (_.isEmpty(name)) {
        this.ui.name.closest(".form-group").addClass("has-error");
      }
      else {
          var that = this;
          this.ui.nameForm.ajaxForm({
              "url": "rest/optimizations/"+that.model.id+"/copy",
              type: "POST",
              success: function(data){
                  //var url = location.hash;
                  md.close();
                  var url = "#project/optimizations/" + data.id + "/parameters/view";
                  window.App.navigate(url, { trigger: true });
                  window.alertify.success("Оптимизация скопирована");
              },
              statusCode: {
                  404: function () {
                      window.alertify.error("Ошибка");
                  }
              }
          }).submit();
      }
    }
  });
}());