var OptimizationOptimusAlgorithmSelectedParameter = Backbone.Model.extend({
  urlRoot: function () {
    if (this.collection.options.type !== "runParams") {
      return "rest/optimizations/" + this.collection.options.optimizationId + "/Optimus/" + this.collection.options.type + "/params";
    } else {
      return "rest/optimizations/" + this.collection.options.optimizationId + "/Optimus/runParams"
    }
  }
});

var OptimizationOptimusAlgorithmParameters = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Optimus/" + this.options.type;
  },

  initialize: function (collection, options) {
    this.options = options || {};
  }
});

var OptimizationOptimusAlgorithmSelectedParameters = Backbone.Collection.extend({
  url: function () {
    if (this.options.type !== "runParams") {
      return "rest/optimizations/" + this.options.optimizationId + "/Optimus/" + this.options.type + "/selected";
    } else {
      return "rest/optimizations/" + this.options.optimizationId + "/Optimus/runParams"
    }
  },

  initialize: function (models, options) {
    this.options = options || {};
  },

  model: OptimizationOptimusAlgorithmSelectedParameter
});

window.OptimizationOptimusAlgorithm = React.createClass({
  getInitialState: function () {
    return {
      methods: new OptimizationOptimusAlgorithmParameters(null, {
        optimizationId: this.props.optimizationId,
        type: "methods"
      }),
      does: new OptimizationOptimusAlgorithmParameters(null, {
        optimizationId: this.props.optimizationId,
        type: "does"
      }),
      selectedMethodParameters: new OptimizationOptimusAlgorithmSelectedParameters(null, {
        optimizationId: this.props.optimizationId,
        type: "methods"
      }),
      selectedDoeParameters: new OptimizationOptimusAlgorithmSelectedParameters(null, {
        optimizationId: this.props.optimizationId,
        type: "does"
      }),
      runParameters: new OptimizationOptimusAlgorithmSelectedParameters(null, {
        optimizationId: this.props.optimizationId,
        type: "runParams"
      })
    }
  },
  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },

  componentDidMount: function () {
    this.totalUpdate();
    this.updateRunParameters();
    window.App.commands.setHandler("basic:NUM_TARGET_FUNCS:changed", () => this.totalUpdate());
  },

  totalUpdate: function () {
    this.updateMethods().then(() => {
      this.updateDoes().then(() => {
        this.updateSelectedDoe().then(() => {
          this.updateSelectedMethods().then(() => {
            this.forceUpdate();
          }, null)
        }, null)
      });
    });
  },

  updateRunParameters: function () {
    this.state.runParameters.fetch().done(() => {
      this.forceUpdate();
    });
  },

  updateMethods: function () {
    return new Promise((resolve, reject) => {
      this.state.methods.fetch({
        success: resolve,
        error: reject
      });
    });
  },


  updateDoes: function () {
    return new Promise((resolve, reject) => {
      this.state.does.fetch({
        success: resolve,
        error: reject
      });
    });
  },

  updateSelectedMethods: function () {
    return new Promise((resolve, reject) => {
      this.state.selectedMethodParameters.fetch({
        success: resolve,
        error: reject
      });
    });
  },

  updateSelectedDoe: function () {
    return new Promise((resolve, reject) => {
      this.state.selectedDoeParameters.fetch({
        success: resolve,
        error: reject
      });
    });
  },

  onMethodsChange: function () {
    this.updateSelectedMethods().then(() => {
      this.updateDoes().then(() => {
        this.updateSelectedDoe().then(() => {
          this.forceUpdate();
        }, null)
      });
    }, null)
  },

  onDoesChange: function () {
    this.updateSelectedDoe().then(() => {
      this.forceUpdate();
    }, null);
  },

  render: function () {
    return (
      <div className="row">
        <div className="col-lg-4">
          <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
            <div className="ui-optimization-block-header clearfix">
              <span className="pull-left">Метод оптимизации</span>
              <div className="btn-group pull-right">
                <button className="btn btn-info btn-xs ui-minimize js-minimize" onClick={this.onMinimizeClick}>
                  <span>Свернуть</span>
                  <span style={{display: "none"}}>Развернуть</span>
                </button>
              </div>
            </div>
            <div className="ui-optimization-block-body">
              <window.OptimizationOptimusAlgorithmMethods onChange={this.onMethodsChange} methods={this.state.methods} {...this.props} />
              <div className="ui-optimization-algorithm-wrap">
                <form className="form-horizontal">
                  <window.OptimizationOptimusMethodParameters isView={this.props.isView} parameters={this.state.selectedMethodParameters} />
                </form>
              </div>
            </div>
          </div>
        </div>
        <div className="col-lg-4">
          <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
            <div className="ui-optimization-block-header clearfix">
              <span className="pull-left">Планирование эксперимента</span>
              <div className="btn-group pull-right">
                <button className="btn btn-info btn-xs ui-minimize js-minimize" onClick={this.onMinimizeClick}>
                  <span>Свернуть</span>
                  <span style={{display: "none"}}>Развернуть</span>
                </button>
              </div>
            </div>
            <div className="ui-optimization-block-body">
              <window.OptimizationOptimusAlgorithmDoes onChange={this.onDoesChange} does={this.state.does} {...this.props} />
              <div className="ui-optimization-algorithm-wrap">
                <form className="form-horizontal">
                  <window.OptimizationOptimusDoeParameters isView={this.props.isView} parameters={this.state.selectedDoeParameters} />
                </form>
              </div>
            </div>
          </div>
        </div>
        <div className="col-lg-4">
          <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
            <div className="ui-optimization-block-header clearfix">
              <span className="pull-left">Параметры запуска</span>
              <div className="btn-group pull-right">
                <button className="btn btn-info btn-xs ui-minimize js-minimize" onClick={this.onMinimizeClick}>
                  <span>Свернуть</span>
                  <span style={{display: "none"}}>Развернуть</span>
                </button>
              </div>
            </div>
            <div className="ui-optimization-block-body">
              <div className="ui-optimization-algorithm-wrap">
                <form className="form-horizontal">
                  <window.OptimizationOptimusRunParameters isView={this.props.isView} parameters={this.state.runParameters} />
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
    )
  }
});
