var OptimizationOptimusBorders = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Optimus/cad-borders";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

window.OptimizationOptimusCADBorders = React.createClass({
  getInitialState: function () {
    return {
      borders: new OptimizationOptimusBorders(null, { optimizationId: this.props.optimizationId, borderType: this.props.borderType })
    };
  },
  componentDidMount: function () {
    this.fetchData();
    window.App.commands.setHandler("basic:NUM_CAD_VARYING_PARAMS:changed", () => {
      this.fetchData();
    });
  },
  fetchData: function () {
    this.state.borders.fetch().done(() => {
      this.forceUpdate();
    });
  },
  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },
  render: function () {
    var borders = this.state.borders.toJSON().map((parameter) => {
      return <window.OptimizationOptimusBorder isView={this.props.isView} onChange={this.props.onChange} borderType="cad-borders" key={parameter.id} data={parameter}/>
    });
    return (
      <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
        <div className="ui-optimization-block-header clearfix">
          <span className="pull-left">Границы CAO-параметров</span>
        </div>
        <div className="ui-optimization-block-body">
          <div className="row" style={{"marginBottom": "7px"}}>
            <div className="col-md-1">Параметр</div>
            <div className="col-md-2">Нижняя граница</div>
            <div className="col-md-2">Верхняя граница</div>
            <div className="col-md-2">Дискретизация</div>
            <div className="col-md-2">Шаг варьирования</div>
          </div>
          {borders}
        </div>
      </div>
    )
  }
});