var OptimizationOptimusFunctions = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Optimus/targetFunctions";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

window.OptimizationOptimusFunctions = React.createClass({
  getInitialState: function () {
    return {
      functions: new OptimizationOptimusFunctions(null, { optimizationId: this.props.optimizationId }),
      types: []
    };
  },
  componentDidMount: function () {
    this.fetchData(this.fetchTypes);
    window.App.commands.setHandler("basic:NUM_TARGET_FUNCS:changed", () => {
      this.fetchData();
    });
  },
  fetchTypes: function () {
    $.get("rest/optimizations/Optimus/targetFunctions/types", (types) => {
      this.setState({ types: types });
    });
  },
  fetchData: function (handler) {
    this.state.functions.fetch().done(() => {
      if (typeof handler === "function") {
        handler.call(this);
      } else {
        this.forceUpdate();
      }
    });
  },
  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },
  render: function () {
    var functions = this.state.functions.toJSON().map((parameter) => {
      return <window.OptimizationOptimusFunction isView={this.props.isView} onChange={this.props.onChange} key={parameter.id} data={parameter} types={this.state.types}/>
    });
    return (
      <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
        <div className="ui-optimization-block-header clearfix">
          <span className="pull-left">Границы варьируемых параметров</span>
        </div>
        <div className="ui-optimization-block-body">
          <div className="row" style={{"marginBottom": "7px"}}>
            <div className="col-md-1">Параметр</div>
            <div className="col-md-2">Функция</div>
          </div>
          {functions}
        </div>
      </div>
    )
  }
});