window.OptimizationOptistructSet = React.createClass({
  getInitialState: function () {
    return this.props.data;
  },

  onClickSet: function (e) {
    if (!$(e.target).hasClass("fa")) {
      let state = this.state;
      state.isOptimizationSpace = !this.state.isOptimizationSpace;
      this.updateState(state);
      this.props.toggleActive(this.state.id);
    }
  },

  componentDidMount: function () {
    window.App.vent.on("set:toggle:active", this.setActive);
  },

  componentWillUnmount: function () {
    window.App.vent.off("set:toggle:active");
  },

  setActive: function (id) {
    let state = this.state;
    if (id !== this.state.id) {
      if (state.isOptimizationSpace) {
        state.isOptimizationSpace = false;
        this.updateState(state);
      }
    }
  },

  updateState: function (state) {
    $.ajax({
      type: "PUT",
      url: "rest/optimizations/" + this.state.optimizationId + "/Optistruct/sets/" + this.state.id,
      contentType: "application/json",
      data: JSON.stringify(state),
      success: (state) => this.setState(state)
    });
  },

  onRemoveClick: function () {
    $.ajax({
      type: "POST",
      url: "rest/optimizations/" + this.state.optimizationId + "/Optistruct/sets/" + this.state.id + "?isSelected=false",
      success: (state) => this.props.onRemoveSet()
    });
  },

  onEditClick: function () {
    window.alertify.prompt("Переименовать группу", "Введите имя", this.state.name, (e, str) => {
      if (str != "") {
        let state = this.state;
        state.name = str;
        this.updateState(state);
      }
    }, null)
  },

  render: function () {
    let errorClass = this.state.isOptimizationSpace ? "success" : "default";
    let opts = {};
    if (this.props.isView) opts["disabled"] = "disabled";
    return (
      <div className="col-md-3">
        <button type="button" className={"ui-optistruct-set clearfix btn btn-" + errorClass} {...opts}
                onClick={this.onClickSet}>
          <span className="pull-left">{this.state.name}</span>
          <span className="pull-right">
            <i className="fa fa-pencil ui-set-icons" aria-hidden="true" onClick={this.onEditClick}></i>
            <i className="fa fa-times ui-set-icons" aria-hidden="true" onClick={this.onRemoveClick}></i>
          </span>
        </button>
      </div>
    )
  }
});