var OptimizationOptistructTechnologicalConstraints = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Optistruct/technologicalConstraints";
  },
  initialize: function (models, options) {
    this.options = options || {};
  }
});

window.OptimizationOptistructTechnologicalConstraints = React.createClass({
  getInitialState: function () {
    return {
      constraints: new OptimizationOptistructTechnologicalConstraints(null, {optimizationId: this.props.optimizationId}),
      types: []
    };
  },

  componentDidMount: function () {
    this.totalUpdate();
    window.App.commands.setHandler("basic:NUM_TECH_CONSTRAINTS:changed", () => this.totalUpdate());
  },

  totalUpdate: function () {
    this.state.constraints.fetch().done(() => this.fetchTypes());
  },

  fetchTypes: function () {
    $.get("rest/optimizations/Optistruct/technologicalConstraints").then((technologicalConstraintsDictionary) => this.setState({ technologicalConstraintsDictionary: technologicalConstraintsDictionary }));
  },

  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },

  mapConstraints: function () {
    return this.state.constraints.toJSON().map((constraint) => {
      return <window.OptimizationOptistructTechnologicalConstraint isView={this.props.isView} onChange={this.props.onChange} key={constraint.id} data={constraint} technologicalConstraintsDictionary={this.state.technologicalConstraintsDictionary} />
    });
  },

  render: function () {
    return (
      <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
        <div className="ui-optimization-block-header clearfix">
          <span className="pull-left">Определение технологических ограничений</span>
        </div>
        <div className="ui-optimization-block-body">
          <div className="row" style={{"marginBottom": "7px"}}>
            <div className="col-md-4">Название</div>
            <div className="col-md-8">Тип ограничения</div>
          </div>
          {this.mapConstraints()}
        </div>
      </div>
    )
  }
});