window.OptimizationAlgorithmParameter = React.createClass({
  getInitialState: function () {
    return this.props.parameter.toJSON();
  },
  componentDidMount: function () {
    this.props.parameter.on("change", () => this.setState(this.props.parameter.toJSON()));
  },

  onChangeCheckbox: function (options, e) {
    let value = this.state.value;
    if (_.isNull(options.parent)) {
      value = e.target.checked;
    } else {
      value[options.indexForChild].value = e.target.checked;
    }
    this.props.parameter.save({value: value}, {
      success: () => {
        this.setState({ value: this.props.parameter.get("value") });
      }
    });
  },

  onChangeInput: function (options, e) {
    if (_.isNull(options.parent)) {
      this.setState({ value: e.target.value });
    } else {
      var currentValue = this.state.value;
      currentValue[options.indexForChild].value = e.target.value;
      this.setState({ value: currentValue });
    }
  },

  onBlurInput: function () {
    this.props.parameter.save(this.state, {
      success: () => this.forceUpdate()
    });
  },

  onChangeSelect: function (options, e) {
    var updatedValue;
    if (_.isNull(options.parent)) {
      updatedValue = this.props.parameter.get("value").map((item) => {
        item.selected = e.target.value == item.name;
        return item;
      });
    } else {
      updatedValue = this.props.parameter.get("value");
      updatedValue[options.indexForChild].value = updatedValue[options.indexForChild].value.map((item) => {
        item.selected = e.target.value == item.name;
        return item;
      });
    }
    this.props.parameter.save({ value: updatedValue }, {
      success: () => {
        this.setState({ value: this.props.parameter.get("value") });
      }
    });
  },

  onChangeSelectedOptionValue: function (index, e) {
    var updatedValue = this.state.value;
    updatedValue[index].value = e.target.value;
    this.setState({ value: updatedValue });
  },

  prepareTemplate: function (parameter, parent, indexForChild) {
    var template;
    switch (parameter.type) {
      case "bool":
        template = <input disabled={this.props.isView} type="checkbox" onChange={this.onChangeCheckbox.bind(null, { parent: parent, indexForChild: indexForChild })} checked={parameter.value} />;
        break;
      case "plain":
        template = <input disabled={this.props.isView} className="form-control" type="text" onBlur={this.onBlurInput.bind(null, { parent: parent, indexForChild: indexForChild })} onChange={this.onChangeInput.bind(null, { parent: parent, indexForChild: indexForChild })} placeholder="Не задано" value={parameter.value || undefined} />
        break;
      case "list":
        let selected = null;
        let list = parameter.value.map((option, index) => {
          if (option.selected) {
            selected = option;
            selected.index = index;
          }
          return <option key={index} value={option.name}>{option.name}</option>
        });

        if (!_.isNull(selected) && selected.custom) {
          template =
            <div className="row">
              <div className="col-md-7">
                <select disabled={this.props.isView} className="form-control" type="text" onChange={this.onChangeSelect.bind(null, { parent: parent, indexForChild: indexForChild })}  value={_.isNull(selected) ? "none" : selected.name }>
                  <option value="none">Не выбрано</option>
                  {list}
                </select>
              </div>
              <div className="col-md-5">
                <input type="text" className="form-control" value={selected.value} onChange={this.onChangeSelectedOptionValue.bind(null, selected.index)} onBlur={this.onBlurInput}/>
              </div>
            </div>;
        } else {
          template =
            <div className="row">
              <div className="col-md-12">
                <select disabled={this.props.isView} className="form-control" type="text" onChange={this.onChangeSelect.bind(null, { parent: parent, indexForChild: indexForChild })}  value={_.isNull(selected) ? "none" : selected.name }>
                  <option value="none">Не выбрано</option>
                  {list}
                </select>
              </div>
            </div>;
        }
        break;
      case "composite":
        template = _.map(this.state.value, (child, index) => {
          return <div key={this.state.id.toString() + index.toString()} className={(this.state.value.length !== index + 1) ? "m-b-10" : ""}>
            {child.name !== "" ?
              <div className="form-group">
              <label className="col-md-3 ui-algorithm-parameter-label">{child.name}</label>
              <div className="col-md-9">{this.prepareTemplate(child, this.state, index)}</div>
            </div> : this.prepareTemplate(child, this.state, index)}
          </div>;
        });
        break;
    }
    return template;
  },

  render: function () {
    var template = this.prepareTemplate(this.state, null, null);
    return (
      <div className="form-group">
        <label className="col-md-5 ui-algorithm-parameter-label">{this.state.name}</label>
        <div className="col-md-7">{template}</div>
      </div>
    );
  }
});