window.OptimizationTechnologicalConstraintField = React.createClass({
  getInitialState: function () {
    this.valueWasChanged = false;
    return this.props.node;
  },

  onChangeCheckbox: function (e) {
    var isChecked = e.target.checked;
    $.ajax({
      type: isChecked ? "PUT" : "DELETE",
      url: this.props.url + "/" + this.state.id,
      contentType: "application/json",
      data: JSON.stringify({ value: null }),
      success: () => {
        this.props.onSelectUpdate();
        this.setState({ isSelected: isChecked });
      }
    });
  },

  onChangeInput: function (e) {
    if (this.state.value != e.target.value) {
      this.valueWasChanged = true;
      this.setState({ value: e.target.value });
    }
  },

  onBlurInput: function (e) {
    if (this.valueWasChanged) {
      var type, value;

      if (!_.isEmpty(e.target.value)) {
        type = "PUT";
        value = e.target.value;
      } else {
        type = "DELETE";
        value = null;
      }

      $.ajax({
        type: type,
        url: this.props.url + "/" + this.state.id,
        contentType: "application/json",
        data: JSON.stringify({value: value}),
        success: () => {
          this.props.onSelectUpdate();
          this.valueWasChanged = false;
          this.setState({value: value});
        }
      });
    }
  },

  onChangeSelect: function (e) {
    var type, selectedId, urlId;

    if (e.target.value == "none") {
      urlId = this.state.selectedId;
      selectedId = null;
      type = "DELETE"
    } else {
      selectedId = urlId = parseInt(e.target.value);
      type = "PUT";
    }

    $.ajax({
      type: type,
      url: this.props.url + "/" + urlId,
      contentType: "application/json",
      data: JSON.stringify({value: null}),
      success: () => {
        this.props.onSelectUpdate();
        this.setState({ selectedId: selectedId });
      }
    });
  },

  prepareTemplate: function () {
    let template;
    let opts = {
      toggle: "tooltip",
      title: _.isNull(this.state.tooltip) ? this.state.displayName : this.state.tooltip
    };

    if (this.props.isChild) {
      opts.styles = {
        paddingLeft: "30px"
      };
    }

    switch (this.state.type) {
      case "checkbox":
        template =
          <div className="row form-group">
            <label className="col-md-5  ui-algorithm-parameter-label" {...opts}>{this.state.displayName}</label>
            <div className="col-md-7">
              <input disabled={this.props.isView || this.state.isDisabled} type="checkbox" onChange={this.onChangeCheckbox}
                     checked={this.state.isSelected}/>
            </div>
          </div>;
        break;
      case "list":
        let list = this.props.node.selectableValues.map((option, index) => {
          return <option key={option.id} value={option.id}>{option.displayName}</option>
        });
        template =
          <div className="row form-group">
            <label className="col-md-5 ui-algorithm-parameter-label" {...opts}>{this.state.displayName}</label>
            <div className="col-md-7">
              <select disabled={this.props.isView || this.state.isDisabled} className="col-md-7 form-control" type="text"
                      onChange={this.onChangeSelect}
                      value={this.state.selectedId || "none"}>
                <option value="none">Не выбрано</option>
                {list}
              </select>
            </div>
          </div>;
        break;
      case null:
        if (this.state.isValueEditable) {
          template =
            <div className="row form-group">
              <label className="col-md-5 ui-algorithm-parameter-label" {...opts}>{this.state.displayName}</label>
              <div className="col-md-7">
                <input disabled={this.props.isView || this.state.isDisabled} className="form-control" type="text" onChange={this.onChangeInput}
                       onBlur={this.onBlurInput} placeholder="Не задано" value={this.state.value || undefined}/>
              </div>
            </div>;
        } else {
          template =
            <div className="row">
              <label
                className="col-md-12 ui-algorithm-parameter-label ui-technological-constraint-parameters-separate-label ui-technological-constraint-parameters-row" {...opts}>{this.state.displayName}</label>
            </div>;
        }
        break;
    }
    return template;
  },

  render: function () {
    return this.prepareTemplate();
  }
});