var OptimizationToscaSelectedParameter = Backbone.Model.extend({
  urlRoot: function () {
      return "rest/optimizations/" + this.collection.options.optimizationId + "/Tosca/methods/params";
  }
});

var OptimizationToscaMethods = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Tosca/methods";
  },

  initialize: function (collection, options) {
    this.options = options || {};
  }
});

var OptimizationToscaMethodParameters = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Tosca/methods/selected";
  },

  initialize: function (models, options) {
    this.options = options || {};
  },

  model: OptimizationToscaSelectedParameter
});

window.OptimizationToscaParameters = React.createClass({
  getInitialState: function () {
    return {
      methods: new OptimizationToscaMethods(null, {optimizationId: this.props.optimizationId}),
      selectedMethodParameters: new OptimizationToscaMethodParameters(null, {
        optimizationId: this.props.optimizationId
      })
    }
  },
  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },

  componentDidMount: function () {
    this.totalUpdate();
  },

  totalUpdate: function () {
    this.updateMethods().then(() => this.updateSelectedMethods().then(() => this.forceUpdate(), null), null);
  },

  updateMethods: function () {
    return new Promise((resolve, reject) => {
      this.state.methods.fetch({
        success: resolve,
        error: reject
      });
    });
  },

  updateSelectedMethods: function () {
    return new Promise((resolve, reject) => {
      this.state.selectedMethodParameters.fetch({
        success: resolve,
        error: reject
      });
    });
  },

  onMethodsChange: function () {
    this.updateSelectedMethods().then(() => this.forceUpdate(), null);
  },

  render: function () {
    return (
      <div className="row">
        <div className="col-lg-12">
          <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
            <div className="ui-optimization-block-header clearfix">
              <span className="pull-left">Метод оптимизации</span>
              <div className="btn-group pull-right">
                <button className="btn btn-info btn-xs ui-minimize js-minimize" onClick={this.onMinimizeClick}>
                  <span>Свернуть</span>
                  <span style={{display: "none"}}>Развернуть</span>
                </button>
              </div>
            </div>
            <div className="ui-optimization-block-body">
              <window.OptimizationToscaMethods onChange={this.onMethodsChange} methods={this.state.methods} {...this.props} />
              <div className="ui-optimization-algorithm-wrap">
                <form className="form-horizontal">
                  <window.OptimizationToscaSelectedMethodsParameters isView={this.props.isView} parameters={this.state.selectedMethodParameters} />
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
    )
  }
});
