(function () {
  "use strict";
  window.App.Views.OptimizationLevelsPage = window.App.Views.BasePage.extend({
    template: "./views/templates/project/optimization/optimization_levels_page.html.ejs",
    regions: _.extend({
      mainRegion: ".js-main-region",
      tableRegion: ".js-table-region",
      graphRegion: ".js-graph-region"
    }, window.App.Views.BasePage.prototype.regions),

    initialize: function () {
      window.App.Views.BasePage.prototype.initialize.apply(this, arguments);
      this.page = "levels";
    },

    onRender: function () {
      this.initAndShowLevels(this.getRegion("mainRegion"));
      this.initAndShowLevelsOptimizations(this.getRegion("tableRegion"));
      window.App.Views.BasePage.prototype.onRender.call(this);
    },

    initAndShowLevels: function (region) {
      var that = this;
      this.levels = new window.App.Collections.OptimizationLevels({optimizationId: this.model.id});
      this.levels.fetch().done(function () {
        region.show(new window.App.Views.OptimizationLevelsView({collection: that.levels}))
      });
    },

    initAndShowLevelsOptimizations: function (region) {
      var options = {};
      this.optimizationSiblingListView = new window.App.Views.OptimizationsListView(_.extend({
        gridCollection: new App.Collections.Optimizations([], {
          siblings: true,
          optimizationId: this.model.id,
          pageable: true,
          filters: options.filters || null
        }),
        actions: ["open", "new"],
        type: "optimizations"
      }, options));
      region.show(this.optimizationSiblingListView)
    }

  });

})();