(function () {
  "use strict";

  window.App.Views.ParameterValuesTableValue = Marionette.ItemView.extend({
    template: "./views/templates/project/parameter/parameter_table_value.html.ejs",
    tagName: "tr",

    ui: {
      removeValue: ".js-remove-value"
    },

    events: {
      "click @ui.removeValue": "onRemoveValueClick"
    },

    initialize: function (options) {
      this.options = options || {};
      this.listenTo(this.model, "change", this.triggerChangeToCollection);
    },

    triggerChangeToCollection: function () {
      this.model.collection.trigger("model:updated");
    },

    onRemoveValueClick: function () {
      this.model.destroy();
    }

  });

}());