(function () {
  "use strict";

  window.App.Views.ParameterValuesChartView = Marionette.ItemView.extend({
    template: "./views/templates/project/parameter/parameter_values_chart.html.ejs",
    collectionEvents: {
      "destroy": "showChart",
      "add": "showChart",
      "model:updated": "showChart"
    },

    initialize: function (options) {
      this.options = options || {};
    },

    onShow: function () {
      this.showChart();
    },

    mapChartData: function () {
      var columns = [
        ["T"],
        [this.options.currentParameter.get("paramName")]
      ];
      this.collection.each(function (model) {
        columns[0].push(model.get("temperature"));
        columns[1].push(model.get("paramValue"));
      });
      return columns;
    },

    showChart: function () {
      this.chart = c3.generate({
        bindto: ".js-chart-container",
        data: {
          x: "T",
          columns: this.mapChartData()
        }
      });
    }


  });

}());