(function () {
  'use strict';

  window.App.Views.PreviewCellView = Marionette.ItemView.extend({
    template: './views/templates/project/results/preview_cell.html.ejs',
    ui: {
      preview: ".js-preview"
    },
    events: {
      "click @ui.preview": "onPreviewClick"
    },

    onPreviewClick: function () {
      new Backbone.BootstrapModal({
        content: new window.App.Views.PreviewContentView({ model: this.model }),
        title: "Просмотр",
        animate: true,
        allowCancel: false,
        cancelText: "Отменить",
        okText: "Закрыть",
        modalWidth: $(window).width() * 0.8
      }).open();
    },

    templateHelpers: function () {
      var that = this;
      return {
        faIconClass: function () {
          var faIconClass;
          switch(that.model.get('type')) {
            case 'pictures':
              faIconClass = 'fa-file-image-o';
              break;
            case 'animations':
              faIconClass = 'fa-film';
              break;
            case 'presentations':
              faIconClass = 'fa-file-pdf-o';
              break;
            case 'curves':
              faIconClass = 'fa-random';
              break;
            case 'stlVisualisation':
              //if (that.model.get('pathToFile').slice(-3)==='stl') {
                faIconClass = 'fa-play-circle';
              //}
              break;
            default:
              faIconClass = 'fa-ban';
              break;
          }
          return faIconClass;
        }
      }
    }
  });


})();