(function () {
  'use strict';

  window.App.Views.PreviewContentView = Marionette.LayoutView.extend({
    template: null,
    className: "ui-curve row",

    initialize: function () {
      this.listenTo(this, 'shown', this.model.get('type')==='stlVisualisation' ? this.showAnimation : this.showCurve);
    },

    onBeforeRender: function () {
      this.setTemplate();
    },

    showCurve: function () {
      $.get('rest/results/' + this.model.id + "/preview", (curve) => window.App.Helpers.CurveView.showCurve(curve));
    },

    showAnimation: function(){
      $.get('rest/results/' + this.model.id , (Obj) => window.App.Helpers.AnimationView.showAnimation(Obj));
    },

    setTemplate: function () {
      switch (this.model.get('type')) {
        case 'pictures':
          this.template = './views/templates/project/results/preview_image.html.ejs';
          break;
        case 'curves':
          this.template = './views/templates/project/results/preview_curve.html.ejs';
          break;
        case 'stlVisualisation':
          this.template = './views/templates/project/results/preview_animation.html.ejs';
          break;
        default:
          this.template = './views/templates/project/results/preview_image.html.ejs';
          break
      }
    }

  });

})();