(function () {
  "use strict";

  window.App.Views.SupportView = Backbone.Marionette.LayoutView.extend({
    template: "./views/templates/project/support/support.html.ejs",
    ui: {
      "text": ".js-text"
    },

    events: {
      "change @ui.text": "onTextChange"
    },

    initialize: function () {
      this.listenTo(this, "ok", this.onSubmit);
      this.listenTo(this, "cancel", this.onCancel);
    },

    onTextChange: function () {
      if (!_.isEmpty(this.ui.text.val())) {
        this.ui.text.closest(".form-group").removeClass("has-error");
      }
    },

    onSubmit: function (md) {
      md.preventClose();
      var text = this.ui.text.val();
      if (!_.isEmpty(text)) {
        $.ajax({
          type: "POST",
          url: "rest/support",
          contentType: "application/json",
          data: JSON.stringify({
            content: text,
            pageUrl: window.location.href
          }),
          success: function () {
            window.alertify.success("Сообщение отправлено в службу технической поддержки");
            md.close();
          }
        })
      } else {
        this.ui.text.closest(".form-group").addClass("has-error");
        window.alertify.error("Сообщение не может быть пустым");
      }
    }

  });


})();