(function () {
  "use strict";

  window.App.Views.CopyTechnologySimulationView = Marionette.LayoutView.extend({
    template: "./views/templates/project/technology/copy_technology_simulation.html.ejs",
    className: "copy-technology-simulation row",

    regions: {
      mainRegion: ".js-main-region"
    },

    ui: {
      name: ".js-name",
      nameForm: ".js-name-form"
    },

    initialize: function (options) {
      this.options = options || {};
      this.listenTo(this, "ok", this.onSubmit);
    },

    passModal: function (md) {
      this.md = md;
    },

    onSubmit: function (md) {
      md.preventClose();
      var name = this.ui.name.val();
      this.$(".form-group").removeClass('has-error');
      if (_.isEmpty(name)) {
        this.ui.name.closest(".form-group").addClass("has-error");
      }
      else {
          var that = this;
          this.ui.nameForm.ajaxForm({
              "url": "rest/technologySimulations/"+that.model.id+"/copy",
              type: "POST",
              success: function(data){
                  md.close();
                  var url = "#project/technologySimulations/" + data.id + "/parameters/view";
                  window.App.navigate(url, { trigger: true });
                  window.alertify.success("Технологический расчет скопирован");
              },
              statusCode: {
                  404: function () {
                      window.alertify.error("Ошибка");
                  }
              }
          }).submit();
      }
    }
  });
}());