(function () {
  "use strict";

  window.App.Views.CreateTechnologyView = Marionette.LayoutView.extend({
    template: "./views/templates/project/technology/create_technology.html.ejs",
    className: "create-technology row",

    behaviors: {
      PluginsInit: {
        fileupload: {
          el: "#js-file-upload"
        },
        ajaxFormConfig: {}
      }
    },

    ui: {
      name: ".js-name",
      type: ".js-type",
      video: ".js-video",
      file: ".js-file",
      fileForm: ".js-file-form"
    },

    initialize: function () {
      this.model = new window.App.Models.Technology();
      this.listenTo(this, "ok", this.onSubmit);
      this.listenTo(this, "cancel", this.onCancel);
    },

    passModal: function (md) {
      this.md = md;
    },

    onCancel: function () {
      window.App.navigate("#project/technologies", { trigger: true });
    },

    saveDocument: function (id, md) {
      if (!_.isEmpty(this.ui.file.val())) {
        this.ui.fileForm.ajaxForm({
          type: "POST",
          url: "rest/technologies/" + id + "/descriptionFile",
          success: function () {
            window.App.navigate("#project/technologies/" + id + "/parameters/edit", {trigger: true});
            window.App.vent.trigger('updateTreeNodes', null, window.App.Data.Trees[1].type, null, "add");
            md.close();
          },
          error: function () {}
        }).submit();
      }
    },

    onSubmit: function (md) {
      var that = this;
      md.preventClose();
      var name = this.ui.name.val();

      if (_.isEmpty(name))
        this.ui.name.closest(".form-group").addClass("has-error");
      else
        this.model.save({
          name: name,
          type: this.ui.type.val(),
          video: this.ui.video.val()
        }, {
          success: function (model, resp) {
            that.saveDocument(model.id, md);
          }
        });
    }

  });

}());