(function() {
  "use strict";
  window.App.Views.TechnologyFilesPage = window.App.Views.BasePage.extend({
    template: "./views/templates/project/technology/technology_files_page.html.ejs",

    initialize: function (options) {
      window.App.Views.MaterialFilesPage.__super__.initialize.apply(this, arguments);
      this.controls = ["new"];
      this.page = this.options.fileType;
      this.pageTitle = this.model.get("name");
    },

    onShow: function () {
      this.initAndDrawTables();
    },

    initAndDrawTables: function () {
      this.filesView = new window.App.Views.FilesListView(_.extend({
        gridCollection: new window.App.Collections.Files([], {
          objectId: this.model.id,
          objectType: "tehnologies",
          fileType: this.options.fileType,
          pageable: true,
          filters: this.options.filters || null
        }),
        actions: ["new", "export"],
        isFile: true,
        title: "Виртуальные симуляции"
      }, {}));
      this.getRegion("mainRegion").show(this.filesView);
    }

  });

})();