package ru.crp.lvms;

import com.fasterxml.jackson.databind.JsonNode;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.model.entities.simulations.SimulationEntity;
import ru.crp.lvms.utils.TestUtils;
import ru.crp.lvms.utils.URLs;

import java.util.List;
import java.util.function.Function;
import java.util.function.Supplier;

import static org.junit.Assert.assertEquals;
import static ru.crp.lvms.utils.TestUtils.unique;

public class SimulationEndpointIT extends CRUDIT<SimulationEntity, SimulationEntity> {
    @Override
    public String setUrl() {
        return URLs.SIMULATIONS_URL;
    }

    @Override
    public Supplier<SimulationEntity> setEntityCreator() {
        return projectCreator::createSimulation;
    }

    @Override
    public Supplier<SimulationEntity> setEntityInitialisation() {
        return projectCreator::newSimulation;
    }

    @Override
    public Function<JsonNode, List<? extends Entity>> setJsonFromList() {
        return TestUtils::simulationsFromJson;
    }

    @Override
    public Function<JsonNode, List<? extends Entity>> setJsonFromPage() {
        return TestUtils::simulationsPageFromJson;
    }

    @Override
    public void update(SimulationEntity toUpdate) {
        toUpdate.setName(unique("name"));
    }

    @Override
    public void validateAfterUpdate(SimulationEntity before, SimulationEntity after) {
        assertEquals(before.getName(), after.getName());
    }
}
