package ru.crp.lvms;

import org.junit.Ignore;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import ru.crp.cmlb.model.entities.FileData;
import ru.crp.cmlb.model.entities.ResourcePreparationException;
import ru.crp.lvms.model.entities.tasks.TaskEntity;
import ru.crp.lvms.tasks.fileGenerators.ECInputFileGenerator;
import ru.crp.lvms.tasks.fileGenerators.SimulationInputFileGenerator;

import java.io.IOException;
import java.nio.file.Files;
import java.util.List;

public class SolvingInputFileGeneratorIT extends BaseIT {

    @Autowired
    private ECInputFileGenerator ecInputFileGenerator;

    @Autowired
    private SimulationInputFileGenerator simulationInputFileGenerator;


    @Test
    public void ecInputFileMustBeGeneratedWithoutExceptions() throws IOException, ResourcePreparationException {
        TaskEntity taskEntity = projectCreator.createTask();
        List<FileData> output = ecInputFileGenerator.getInputFilesForEffectiveCharacteristics(taskEntity);
        Files.deleteIfExists(output.get(0).getPathToFile());
    }

    @Test
    @Ignore
    public void bendInputFileMustBeGeneratedWithoutExceptions() throws Exception {
        TaskEntity taskEntity = projectCreator.newSolvingTask();
        taskEntity = projectCreator.createTask(taskEntity);
        List<FileData> output = simulationInputFileGenerator.getInputFilesForBendSimulation(taskEntity);
        Files.deleteIfExists(output.get(0).getPathToFile());
    }

    @Test
    @Ignore
    public void tensionInputFileMustBeGeneratedWithoutExceptions() throws Exception {
        TaskEntity taskEntity = projectCreator.newSolvingTask();
        taskEntity = projectCreator.createTask(taskEntity);
        List<FileData> output = simulationInputFileGenerator.getInputFilesForTensionSimulation(taskEntity);
        Files.deleteIfExists(output.get(0).getPathToFile());
    }

    @Test
    @Ignore
    public void thermalInputFileMustBeGeneratedWithoutExceptions() throws Exception {
        TaskEntity taskEntity = projectCreator.newSolvingTask();
        taskEntity = projectCreator.createTask(taskEntity);
        List<FileData> output = simulationInputFileGenerator.getInputFilesForThermalSimulation(taskEntity);
        Files.deleteIfExists(output.get(0).getPathToFile());
    }
}
