package ru.crp.lvms.technologies;

import com.fasterxml.jackson.databind.JsonNode;
import org.junit.Assert;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.CRUDIT;
import ru.crp.lvms.model.entities.EquipmentEntity;
import ru.crp.lvms.utils.TestUtils;

import java.util.List;
import java.util.function.Function;
import java.util.function.Supplier;

public class EquipmentEndpointIT extends CRUDIT<EquipmentEntity, EquipmentEntity> {

    @Override
    public String setUrl() {
        return projectCreator.getUrlForEquipments();
    }

    @Override
    public Supplier<EquipmentEntity> setEntityCreator() {
        return projectCreator::createEquipment;
    }

    @Override
    public Supplier<EquipmentEntity> setEntityInitialisation() {
        return projectCreator::newEquipment;
    }

    @Override
    public Function<JsonNode, List<? extends Entity>> setJsonFromList() {
        return TestUtils::equipmentFromJson;
    }

    @Override
    public Function<JsonNode, List<? extends Entity>> setJsonFromPage() {
        return TestUtils::equipmentPageFromJson;
    }

    @Override
    public void update(EquipmentEntity toUpdate) {
        toUpdate.setName("testName");
    }

    @Override
    public void validateAfterUpdate(EquipmentEntity before, EquipmentEntity after) {
        Assert.assertEquals(before.getName(), after.getName());
    }
}
